#ifndef __CONFIG_H
#define __CONFIG_H

#ifdef __linux__
#  define stricmp strcasecmp
#  define strnicmp strncasecmp
#endif

#if defined (__linux__)
#  define OPSYS "Linux"
#elif defined (__OS2__)
#  define OPSYS "2"
#elif defined (__DOS__)
#  define OPSYS "DOS"
#else
#  error Unknown operating system!
#endif

#ifdef __linux__
#  define config_file "/etc/xfix.conf"
#else
#  define config_file "xfix.cfg"
#endif

#define VERSION "1.0b"
#define CREATED "Xfix/"OPSYS" v"VERSION" - Copyright (c) 1997 Timo Sirainen"

typedef struct ADDR_REC
{
    ADDR_REC *next;

    unsigned short zone, net, node, point;
}
ADDR_REC;

typedef struct XFIX_REC
{
    XFIX_REC *next;

    char tag[61];
    char *path;
    ADDR_REC *import;
    ADDR_REC *export;
}
XFIX_REC;

typedef struct XNODE_REC
{
    XNODE_REC *next;

    ADDR_REC expaddr;
    ADDR_REC ownaddr;
    char password[9];
}
XNODE_REC;

typedef struct HATCH_REC
{
    HATCH_REC *next;

    char area[61];
#ifdef __WATCOMC__
    char fname[];
#else
    char fname[0];
#endif
}
HATCH_REC;

typedef struct
{
    char fname[256];
    unsigned long time;
}
XDAT_REC;

extern XFIX_REC *xfirst, *xrec;
extern XNODE_REC *firstnode, *noderec;
extern HATCH_REC *firsthatch, *hatchrec;
extern char inbound[256], outbound[256], safein[256], ticpath[256], badtics[256];

int str2addr(char *addrstrp, unsigned short *zone, unsigned short *net, unsigned short *node, unsigned short *point);
int read_config(char *fname);

#endif
