#ifndef __FILES_H
#define __FILES_H

/* Includes */
#include <fcntl.h>
#include <sys/stat.h>

#ifdef __linux__
#  include <unistd.h>
#  include <dirent.h>
#else
#  include <io.h>
#  include <share.h>
#  include <direct.h>
#endif

/* Defines */
#ifdef __linux__
#  define READWRITE 0660
#  define O_BINARY 0
#  define SH_DENYNO 0
#  define SH_DENYRW 0
#  define ISDIR(a) S_ISDIR(a.st_mode)
#  define flock(a,b,c) lockf(a,F_LOCK,b)
#  define funlock(a,b,c) lockf(a,F_ULOCK,b)
#  define sopen(a,b,c) open(a,b)
inline int MakeDir(char *path)
{
    int ret;

    ret = mkdir(path, 0770);
    if (ret == 0) chmod(path, 0770);
    return ret;
}
#  define setmode(a,b)
#  define SLASH '/'
#  define SSLASH "/"
#  define ftrunc(a,b) ftruncate(a,b)
#else
#  define READWRITE (S_IREAD | S_IWRITE)
#  define ISDIR(a) (((a.st_attr) & _A_SUBDIR) == _A_SUBDIR)
#  define flock(a,b,c) lock(a,b,c)
#  define funlock(a,b,c) unlock(a,b,c)
#  define MakeDir(a) mkdir(a)
#  define SLASH '\\'
#  define SSLASH "\\"
#  define ftrunc(a,b) chsize(a,b)
#endif

int copyfile(char *source, char *dest);
int delete_space(int handle, long pos, long size, long fsize);

int lockfile(int handle);
#define unlockfile(a) funlock(a, 0, 1);

char *_fgets(char *buf, size_t n, FILE *fp);
char *__fgets(char *buf, size_t n, int handle);

#ifdef __linux__
char *search_ign_file(char *fname);
#endif

#endif
