#include <stdio.h>
#include <string.h>

#include "config.h"
#include "files.h"

/* Create file attaches to outbound */
int update_outbound(char *tickname, char *fname, ADDR_REC *addr)
{
    FILE *Fflo;
    char outb[256], path[256];
    struct stat statbuf;

    /* Outbound directory name */
    if (addr->zone == addr->zone)
        strcpy(outb, outbound);
    else
        sprintf(outb, "%s.%03x",outbound,addr->zone);

    if (addr->point != 0)
    {
        /* Point, put to .PNT directory. */
        sprintf(outb+strlen(outb), SSLASH"%04x%04x.PNT", addr->net, addr->node);
    }

    /* Create directory if doesn't exist */
    if (stat(outb, &statbuf) != 0)
    {
        if (MakeDir(outb) != 0)
        {
            printf("Could not create directory %s\n", outb);
            return 0;
        }
    }

    /* .FLO file name */
    if (addr->point == 0)
        sprintf(path, "%s"SSLASH"%04x%04x.flo", outb, addr->net, addr->node);
    else
        sprintf(path, "%s"SSLASH"%08x.flo", outb, addr->point);

    Fflo = fopen(path, "a+t");
    if (Fflo == NULL)
    {
        printf("Can't append to file %s\n", path);
        return 0;
    }
#ifdef __linux__
    chmod(path, 0660);
#endif
    fprintf(Fflo, "%s\n", fname);
    fprintf(Fflo, "^%s\n", tickname);
    fclose(Fflo);

    return 1;
}
