/* Xfix v1.0b - Copyright (c) 1997 Timo Sirainen

TODO:
 - Filefind manager
 - replaces-kentn kytt
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "config.h"
#include "files.h"
#include "ticks.h"
#include "hatch.h"

/* Search .tics from directory and toss them */
void toss_tics(char *dir)
{
    DIR *dirp;
    struct dirent *direntp;
    char *ext;

    printf("Scanning directory %s for .tic files..\n", dir);

    dirp = opendir(dir);
    if (dirp == NULL)
    {
        printf("Can't open directory %s\n", dir);
        return;
    }

    for (;;)
    {
        direntp = readdir(dirp);
        if (direntp == NULL) break;

        ext = strrchr(direntp->d_name, '.');
        if (ext == NULL) continue;
        if (stricmp(ext, ".tic") != 0) continue;

        /* .tic file found. */
        process_tic(dir, direntp->d_name);
    }
}

void help(void)
{
    printf("Usage: xfix [toss] [scan] [tossbad] [hatch <area> <file name>]\n\n");
    printf(" toss   : Scan inbound for .tic files and toss them in file areas\n");
    printf(" scan   : Scan if there's any unsent files in file areas to hatch\n");
    printf(" tossbad: Toss .tic files from bad area\n");
    printf(" hatch  : Hatch file <file name> to file echo <area>\n");
    exit(0);
}

int main(int argc, char *argv[])
{
    printf("\nXfix "VERSION" - Copyright (c) 1997 Timo Sirainen\n\n");

    if (!read_config(config_file)) return 1;

    if (argc == 1) help();
    if (stricmp(argv[1], "TOSS") == 0)
    {
        /* Toss from inbound */
        toss_tics(inbound);
        if (safein[0] != '\0') toss_tics(safein);
    }
    else if (stricmp(argv[1], "SCAN") == 0)
    {
        /* Scan hatches */
        hatch_mgr();
    }
    else if (stricmp(argv[1], "TOSSBAD") == 0)
    {
        /* Toss from bad area */
        toss_tics(badtics);
    }
    else if (stricmp(argv[1], "HATCH") == 0)
    {
        create_tick(argv[3], argv[2]);
    }
    else help();

    return 0;
}
