#ifndef __CONFIG_H
#define __CONFIG_H

typedef struct ADDR_REC
{
    struct ADDR_REC *pNext;                     /* Next address */

    unsigned short wZone,wNode,wNet,wPoint;     /* Address */
#ifdef __WATCOMC__
    char szDomain[];                            /* Domain */
#else
    char szDomain[0];                           /* Domain */
#endif
}
ADDR_REC;

typedef struct NODE_REC
{
    struct NODE_REC *pNext;                     /* Node node record */

    unsigned short wZone,wNode,wNet,wPoint;     /* Address */

    unsigned short wYourZone,wYourNode;         /* Your address */
    unsigned short wYourNet,wYourPoint;         /* Your address */

    int iPacker;                                /* Packer to use */
    char szPassword[9];                         /* Password to use */
    char szAreaFixPassword[21];                 /* Password to use with areafix */
    char *pszAccessGroups;                      /* Groups this node has access */
#ifdef __WATCOMC__
    char szRoute[];                             /* Route */
#else
    char szRoute[0];                            /* Route */
#endif
}
NODE_REC;

typedef struct PACKER_REC
{
    struct PACKER_REC *pNext;                   /* Next packer record */

    char szIdentify[32];                        /* Identify string */
    char *pszPackString;                        /* Packer string */
    char *pszUnPackString;                      /* Unpacker string */
}
PACKER_REC;

typedef struct MSGAREA_REC
{
    struct MSGAREA_REC *pNext;                  /* Next msg area record */

    char szAreaTag[61];                         /* Area tag */
#ifdef VBOARD
    unsigned short wAreaNum;                    /* Area number */
    char szOrigin[73];                          /* Origin line */
#else
    char *pszPath;                              /* Area path */
#endif
    char szGroup[4];                            /* Area group */
    ADDR_REC OwnAddr;                           /* Own address */
    ADDR_REC *pExport;                          /* Export to addresses */
}
MSGAREA_REC;

extern int iAddresses;
extern ADDR_REC *pFirstAddr;
extern ADDR_REC *pAddrRecord;

extern int iNodes;
extern NODE_REC *pFirstNode;
extern NODE_REC *pNodeRecord;

extern int iPackers;
extern PACKER_REC *pFirstPacker;
extern PACKER_REC *pPackerRecord;

extern int iMsgAreas;
extern MSGAREA_REC *pFirstMsgArea;
extern MSGAREA_REC *pMsgAreaRecord;
extern MSGAREA_REC *pNetmailArea, *pBadMsgArea, *pDupeMsgArea;

extern char *pszInbound;
extern char *pszBaseFile;
extern char *pszDupeFile;
extern char *pszSafeIn;
extern char *pszMsgPath;
extern char *pszOutbound;
extern char *pszTemp;
extern char *pszLogFile;
extern char *pszExportList;
#ifdef VBOARD
extern char *pszVBLogFile;
#endif
extern char *pszSeqFile;
extern char *pszSpool;
#ifdef YAK
extern char YakData[256];
#endif

extern char szMsgAreaPath[256];

extern char szTearLine[76];
extern char szOrigin[70];
extern char szOrganization[80];
extern char szDomain[80];
extern int low_flo, bink_outb, always_slash, domain_outbounds, no_outboundzones;
extern int fSavePacked;

extern int registered;
extern char regname[];

int str2addr(char *addrstrp, unsigned short *zone, unsigned short *net, unsigned short *node, unsigned short *point);

int ReadConfig(char *pszFileName);
void CloseConfig(void);

extern int max_dupes;

#endif
