#include <stdio.h>
#include <string.h>
#include <sys/stat.h>

#define OUTBOUND "d:\\os2progs\\xenia\\"

void str2addr(char *addr, unsigned *zone, unsigned *net, unsigned *node, unsigned *point)
{
    char *pstr,addrstr[30];

    strcpy(addrstr,addr);
    pstr = strchr(addrstr,':');
    if (pstr != NULL) *pstr = ' ';
    pstr = strchr(addrstr,'/');
    if (pstr != NULL) *pstr = ' ';
    pstr = strchr(addrstr,'.');
    if (pstr != NULL) *pstr = ' ';

    *zone = 0; *net = 0; *node = 0; *point = 0;
    sscanf(addrstr,"%u %u %u %u",zone,net,node,point);
}

int main(int argc, char *argv[])
{
    char outb[256],flo[256],clo[256];
    unsigned zone,net,node,point;
    struct stat statbuf;
    FILE *F;

    if (argc != 2)
    {
        printf("Usage: crash <node number>\n");
        return 0;
    }

    str2addr(argv[1],&zone,&net,&node,&point);

    /* Outbound directory name */
    if (zone == 2)
        strcpy(outb, OUTBOUND"outbound");
    else
        sprintf(outb, OUTBOUND"outbound.%03x",zone);

    if (point != 0)
    {
        sprintf(outb+strlen(outb),"\\%04x%04x.pnt",net,node);
        sprintf(flo,"%s\\%08x.",outb,point);
    }
    else
    {
        sprintf(flo,"%s\\%04x%04x.",outb,net,node);
    }

    /* .?LO file name */
    sprintf(clo,"%sclo",flo);
    strcat(flo,"flo");

    if (stat(clo,&statbuf) == 0)
    {
        /* Crash already! */
        printf("Mail is already crashed!\n");
        return 0;
    }

    if (stat(flo,&statbuf) == 0)
    {
        /* FLO file found, rename to CLO file */
        return rename(flo,clo);
    }

    /* No mail to this node, create empty CLO file */
    F = fopen(clo,"w+b");
    if (F == NULL)
    {
        printf("Can't create '%s'\n",clo);
        return 0;
    }
    fclose(F);

    return 0;
}
