/* RoskaBBS - Copyright (c) 1997 Timo Sirainen - read license.txt */

/* logfile.cpp - Log file handling */

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <sys/stat.h>

#include "files.h"

static int hLog = -1, hVBLog = -1;

int OpenLog(char *szFileName, int fVBLog)
{
    int hFile;

    hFile = sopen(szFileName, O_RDWR | O_BINARY, SH_DENYNO);
    if (hFile == -1)
    {
        /* Not found, create. */
        printf("Creating log file '%s'\n",szFileName);
        hFile = creat(szFileName, O_WRONLY | S_IREAD | S_IWRITE);
        if (hFile == -1) return 0;
    }
    else
    {
        lseek(hFile, 0, SEEK_END);
    }

    if (fVBLog) hVBLog = hFile; else hLog = hFile;

    return 1;
}

void CloseLog(void)
{
    if (hLog == -1) return;

    write(hLog, "\r\n", 2);
    close(hLog);

    if (hVBLog != -1) close(hVBLog);
}

void WriteLog(char cType, char *text, ...)
{
    va_list arglist;
    time_t _tim;
    struct tm *tim;
    char tmp[256];

    if (hLog == -1) return;

    /* Get time */
    _tim = time(NULL);
    tim = localtime(&_tim);

    /* Write to XToss's logfile */
    va_start(arglist, text);
    sprintf(tmp,"%c%02d:%02d ", cType, tim->tm_hour, tim->tm_min);
    vsprintf(tmp+strlen(tmp), text, arglist);
    sprintf(tmp+strlen(tmp), "\r\n");
    va_end(arglist);
    write(hLog, tmp, strlen(tmp));

    if ((cType == '+' || cType == '-') && hVBLog != -1)
    {
        /* Write to VBoard's logfile */
        va_start(arglist, text);
        sprintf(tmp,"%c%2d:%02d ", cType, tim->tm_hour, tim->tm_min);
        vsprintf(tmp+strlen(tmp), text, arglist);
        sprintf(tmp+strlen(tmp), "\r\n");
        va_end(arglist);
        write(hVBLog, tmp, strlen(tmp));
    }
}

