#ifndef BBSDEF_H_DEF

/* Constants ... */
#define TRUE                  1
#define FALSE                 0


/* Macros ... */
#define MIN(a,b)              (((a)<(b)) ? (a) : (b))
#define MAX(a,b)              (((a)>(b)) ? (a) : (b))
#define LONGOFFSET(i,s)       ((long)(i)*(long)sizeof(s))

/* Debugging tool ... */
#ifdef DEBUG
  #define DEBUGSTR(s)      Dputs(s "\n\r");
#else
  #define DEBUGSTR(s)
#endif

/* Some general defines */
#ifdef  __MSDOS__
#ifdef  __BORLANDC__
#define p32bit far
#endif
#ifdef __WATCOMC__
#define p32bit __far
#endif
#else
#define p32bit
#endif


#define MKAsk(p,l,o)    (((unsigned short)(p)<<12)|((unsigned short)(l)<<8)|(o))
#define MSGTXT(SZ)      (Message->MsgTxt+((unsigned short)(SZ)*80U))
#define WildStrCmp(P,T) (wstrcmp(P,T)!=TRUE)

/* IsUserGroup returns true if us (usernumber) is group. */
#define IsUserGroup(un)     (un>=65501U && un<=(65500U+MAXUSERGROUPS))

/* UserGroupName returns user group name. Un must be group! */
#define UserGroupName(un)   GConfig.GroupName[un-65501U]

/* Borland spesific defines */
#ifdef __BORLANDC__
#define REG_h     h
#define REG_x     x
#endif

/* WatCom spesific defines */
#ifdef __WATCOMC__
#define REG_h     h
#define REG_x     w
#endif


/* VBoard exit codes ...  */
#define EXIT_NORMAL       0  /* Normal exit. */
#define EXIT_BADARGS      1  /* Invalid command line arguments ... */
#define EXIT_BADCONFIG    2  /* Bad configuration ... */
#define EXIT_OUTOFMEM     3  /* Not enougth memory ... */
#define EXIT_GURU         4  /* Guru meditation ... */
#define EXIT_FILEERROR    5  /* File error, can't open file ... */
#define EXIT_COMERROR     6  /* COM port error, can't open ... */
#define EXIT_MODEMFAILURE 7  /* Can't find modem ... */
#define EXIT_UNKNOWNERR  10  /* Unknown error ... */
#define EXIT_EVENTBASE  100  /* Exit due to event,
                                actual exit number is 100+event number */

/* SendBBSText() options ... */
#define BBSTEXT_LN       0x8000
#define BBSTEXT_ERROR    0x4000
#define BBSTEXT_CMDCOLOR 0x2000
#define BBSTEXT_UNUSED_1 0x1000
#define BBSTEXT_UNUSED_2 0x0800
#define BBSTEXT_UNUSED_3 0x0400
#define BBSTEXT_UNUSED_4 0x0200
#define BBSTEXT_MASK     0x01ff


/* Message load errors */
#define MSG_OK        0
#define MSG_PRIVATE   1
#define MSG_KILLED    2
#define MSG_REMOVED   3
#define MSG_NOTEXISTS 4
#define MSG_HEADFAIL  8
#define MSG_TEXTFAIL  9
#define MSG_NOMEM     10     /* No memory to uncompress */

/* Internal errors... */
#define INT_ERROR_MAKE_PHYSNAME         0x0001
#define INT_ERROR_MARKDOWNLOADED        0x0002
#define INT_ERROR_SAVE_USER             0x0003
#define INT_ERROR_LOAD_USER             0x0004
#define INT_ERROR_MOVE_FILEREC          0x0005


/* Filearea sorting modes */
#define SORT_NONE         0  /* No any sorting */
#define SORT_ALPHA        1  /* Sort files alphabetically */
#define SORT_UPLOADDATE   2  /* Sort files by upload date */
#define SORT_FILESIZE     3  /* Sort files from smalles to biggest */
#define SORT_EXTENSION    4  /* Sort files using extension */

/* SetCommFuncs parameters.. */
#define SCF_NO_CONVESION    0x00
#define SCF_CHAR_CONVESION  0x01


/* Log WriteModes */
#define LOG_CURIOSITY   '.'  /* No essential information ... */
#define LOG_NORMAL      '-'  /* All others ... */
#define LOG_NOTICE      '+'  /* Notice, new files, messages etc ... */
#define LOG_WARN        '*'  /* Warning, something odd or newuser ... */
#define LOG_CRITICAL    '!'  /* Errors ... */
#define LOG_DEBUG       '?'  /* Debugging information ... */

/* File transfer defines */
#define TFILE_UPLOAD        1
#define TFILE_DOWNLOAD      2
#define TOFFLINE_UPLOAD     3
#define TOFFLINE_DOWNLOAD   4


/* MsgEd ReType defines */
#define MSGEDRETYPE_ALL    0x01
#define MSGEDRETYPE_HEADER 0x02
#define MSGEDRETYPE_TEXT   0x00

/* TypeMenu defines */
#define TM_NONE         0x00
#define TM_MORE         0x01
#define TM_COMPLAIN     0x02

/* Offline types */
#define QWK_UPLOAD      0x01
#define QWK_DOWNLOAD    0x02
#define OMEN_UPLOAD     0x03
#define OMEN_DOWNLOAD   0x04
#define BW_UPLOAD       0x05
#define BW_DOWNLOAD     0x06
#define HIPPO_UPLOAD    0x07
#define HIPPO_DOWNLOAD  0x08

/* IsSysOpAvail() return codes ... */
#define ISSYSOPAVAIL_DEFAULT_OFF  0x00
#define ISSYSOPAVAIL_TURNED_OFF   0x01
#define ISSYSOPAVAIL_NOCHAT_FLAG  0x02

#define ISSYSOPAVAIL_AVAILABLE    0x10
#define ISSYSOPAVAIL_DEFAULT_ON   (0x03 | ISSYSOPAVAIL_AVAILABLE)
#define ISSYSOPAVAIL_TURNED_ON    (0x04 | ISSYSOPAVAIL_AVAILABLE)
#define ISSYSOPAVAIL_ALWAYS_FLAG  (0x05 | ISSYSOPAVAIL_AVAILABLE)


/* Ask Area ... */
#define AA_NO_OPTIONS      0x00
#define AA_AUTOTYPEMENU    0x01
#define AA_PARAMONLY       0x02
#define AA_AREAGOT         0x40
#define AA_MENUTYPED       0x80

#define FILEAREA_ROOT      0x0000
#define INVALID_FILE_AREA  0xffff

/* Flags ... */
#define FLAG_OK         0x00
#define FLAG_ALREADY    0x01
#define FLAG_NOSPACE    0x02
#define FLAG_NOTFLAGGED 0x03


/* GENERAL DEFINES! */


#define CONFIGREV            12 /* Config revision */
#define SCRIPTREV             1
#define MAXRETRY             10 /* Max times to retry file opening */
#define BBSTXTSIZE          512 /* True size (lines) of bbstext! */
#define MAXBBSTXTLINELEN    768
#define MAXLINES           5000 /* Maximum lines in messages */
#define MSGTXTSIZE       64000U /* Maximum BYTES in message text */
#define CMD_HISTORYSIZE     768 /* Command line history size ... */
#define NODE_HISTORYSIZE   1024 /* Node message history size ... */
#define MAXRANGE             16 /* Max ranges for msg functions */
#define MAX_HOOK_KEYS        16 /* Maximum number of hotkeys ... */

#define MAXCMD              255 /* Max len of command string ... */
#define MAXCONF            4096 /* Maximum number of confs. 000-FFF */
#define MAXDOORS             64 /* Max doors (Config limitation) */

#ifdef __OS2__
#define MAXFILEAREAS        512
#else
#define MAXFILEAREAS        256 /* Maximum number of fileareas */
#endif

#define MAXUMSG            4096 /* Maximum number of unread msgs in conf */
#define DELAYSIZE           500 /* If not in multitasking DelaySize. */

#define NAMELEN              30 /* Maximum User/Group name lenght */
#define PASSLEN              18 /* Maximum lenght of user password */
#define MAXPROTOCOLS         32 /* Max number of protocols */
#define MAXPACKERS           16 /* Max number of packers */
#define MAXEVENTS            32 /* Max number of events */
#define MAXFLAGS            512 /* Max number of flagged files */
#define MAXAUTOINDENT        40
#define MAXDESCLEN           47 /* Maximum file description line len */
#define MAX_AKA              16 /* Max network addressed. One AKA takes 12 bytes */
#define MAXLINEDELUNDO       24 /* How many deleted lines editor can undo */
#define MAXUSERGROUPS        32 /* Maximum number of user groups */

#define FILENAMELEN          64 /* VBoard datafiles max path len = 40+12+1+3 */

#define MOPEN_MAXRETRY       20 /* Max retries to open file in main directory */
#define MOPEN_DELAY           1 /* Delay in seconds between retries */

#define ON                    1 /* Just generally used defines */
#define OFF                   0
#define SAVE                  1
#define RESTORE               0
#define FLUSH_DELAY         250
#define CONF_NOT_PRESENT 0xffff
#define OPEN_WITH_RDWR     0xfe   /* Only FastLoadMsgHeader()! */

#define MSG_TO_ALL       0x0000
#define MSG_TO_SYSOP     0x0001
#define MSG_TO_YOU       0xffff

/* Reply command options ... */
#define REPLYFLAG_POSTCONF 0x01
#define REPLYFLAG_ASK_CONF 0x02


/* More */
#define MORE_STOP        1  /* Pressed N in --More-- prompt */
#define MORE_QUIT        2  /* Pressed Q in --More-- prompt */

/* Ask word */
#define ASK_WORD_OK      0x00
#define ASK_WORD_NOWORD  0x01
#define ASK_WORD_HELP    0x02


/* Memory allocation */

#define SWAP_GET         0x80  /* 1000 0000 */
#define SWAP_FREE        0x40  /* 0100 0000 */

#define SWAP_MSGTXT      0x01
#define SWAP_MSGBASE     0x02
#define SWAP_MEMCONF     0x04

#define SWAP_ALL              (SWAP_MSGTXT | SWAP_MSGBASE | SWAP_MEMCONF)

/* SysOp availability */
#define USEINISETS            0x00
#define FORCED_ON             0x01
#define FORCED_OFF            0x02

/* User status bits */
#define US_CHATREQ            0x00000001 /* Chat request on */
#define US_HIDED              0x00000002 /* User is hided */
#define US_NONAVAIL           0x00000004 /* Not available */
#define US_NEWFCHECK          0x00000008 /* New files checked */
#define US_CHATTING           0x00000010 /* Chatting in group */
#define US_TEMPSYSOP          0x00000020 /* User has temporary sysop on */
#define US_LOGINCOMMAND       0x00000040 /* User is executing login command */
#define US_INALIAS            0x00000080 /* User is executing alias command */
#define US_NOCHAT             0x00000100 /* Sys Not wanting to chat... */
#define US_TIMELIMITED        0x00000200 /* Time limited by MaxTimeLimit */
#define US_TIMEMODIFIED       0x00000400 /* Got timemodify */
#define US_KICKEDBYSYSOP      0x00000800 /* Kicked by another node */
#define US_SLEEPDISCONNECTED  0x00001000 /* Sleep disconnected */
#define US_TEMPLOCALMODE      0x00002000 /* Temp local mode */
#define US_FILELISTPACKED     0x00004000 /* FileList has been downloaded */
#define US_CREDITSMODIFIED    0x00008000 /* Group credit modify aplied */
#define US_INGROUPCHAT        0x00010000 /* User currently in group chat */
#define US_ALLOWNODEMSGS      0x00020000 /* Disallow nodemessages */
#define US_PENDINGNODEMSG     0x00040000 /* */
#define US_NONSTOP            0x00080000 /* Nonstop mode ... */
#define US_RESTORE_CMDLINE    0x00100000 /* Restore command line ... */


/* Paramaters to commands ... */
#define PRESERVE              0x8000
#define PARAM_ALL             0x0001
#define PARAM_ASK             0x0002
#define PARAM_UNREAD          0x0004
#define PARAM_LOCAL           0x0008
#define PARAM_NET             0x0010
#define PARAM_YES             0x0020
#define PARAM_NO              0x0040
#define PARAM_NONSTOP         0x0080 /* This is not member of parameters! */
#define PARAM_WILD            0x0100
#define PARAM_NUMBER          0x0200
#define PARAM_ONLYONE         0x0400

/* If one of this bits is up then must show F10 information ... */
#define SHOWMORE (US_CHATREQ | US_TEMPSYSOP | US_TEMPLOCALMODE)


#define MENU_GLOB                0x00
#define MENU_MAIN                0x01
#define MENU_READ                0x02
#define MENU_FILE                0x03
#define MENU_SYSOP               0x04
#define MENU_QWK                 0x05
#define MENU_OMEN                0x06
#define MENU_BW                  0x07
#define MENU_BULLETINS           0x08
#define MENU_GOODBYE             0x09
#define MENU_HIPPO               0x0a
#define MENU_SETTINGS            0x0b

#define DOORCMDMENU_MAIN         0x01
#define DOORCMDMENU_READ         0x02
#define DOORCMDMENU_FILE         0x04
#define DOORCMDMENU_SYSOP        0x08
#define DOORCMDMENU_QWK          0x10
#define DOORCMDMENU_OMEN         0x20
#define DOORCMDMENU_BW           0x40
#define DOORCMDMENU_BULLETINS    0x80



/* GROUP ATTRIBUTES */
#define GRP_SHOWMEMBERS     0x01 /* Members will be shown to nonmembers */
#define GRP_HIDDENGROUP     0x02 /* Group is hidden from nonmembers */
#define GRP_USERMAYJOIN     0x04 /* User may freely join the group */
#define GRP_FILESFREE       0x08 /* Private files are free to members */
#define GRP_FILESPRIVATE    0x10 /* Show files to nonmembers */
#define GRP_MODIFYDLCREDITS 0x20 /* Group modifies download credits */
#define GRP_FILESONLYDLABLE 0x40 /* Show files to all, only members can download */
#define GRP_FILEISTOGROUP   0x80 /* Show File is to group: Xxx line */


/* GROUP FILE CAN-I-SEE-IT RETURN VALUES */
#define GFILEPRIVATE  1
#define GFILEHIDDEN   2

/* USEREDITOR SEARCH TYPES */
#define SEARCH_NAMEPATTERN     1
#define SEARCH_ADDRESSCITYECT  2
#define SEARCH_NEWUSER         3
#define SEARCH_KILLEDORNOLOGIN 4
#define SEARCH_GROUPMEMBERSHIP 5
#define SEARCH_USERBITSET      6
#define SEARCH_CALLEDSINCE     7
#define SEARCH_NOTCALLEDSINCE  8
#define SEARCH_CALLEDMORE      9
#define SEARCH_UPLOADEDMORE   10
#define SEARCH_DOWNLOADEDMORE 11

/* HANGUP MODES */
#define HANGUP_SOFT         0x00 /* Hangup only if configured */
#define HANGUP_FORCED       0x01 /* Hangup in any case */

/* StringToUser */
#define STU_NONE            0x00
#define STU_ALLOW_GROUPS    0x01
#define STU_INCLUDE_HIDDEN  0x02
#define STU_USE_ALIAS       0x10

/* DIRECTIONS */
#define UP                  0x01
#define DOWN                0x02
#define RIGHT               0x03
#define LEFT                0x04

/* KEYS */
#define NORMALKEYS          0x01
#define EMACSKEYS           0x02


/* Chars */
#define CHAR_TAB                ('I'-64)
#define CHAR_ESC                (0x1b)
#define CHAR_ENTER              ('M'-64)
#define CHAR_BS                 ('H'-64)
#define CHAR_BACK_SPACE         ('H'-64)
#define CHAR_DEL                (0x7f)

/* Char modifiers */
#define CHAR_EXTENDED           0x8000
#define CHAR_OPCODE             0x4000
#define CHAR_MODEM              0x2000
#define CHAR_LOCAL              0x1000

/* Special keyfuncs that are caused by some event, not keypress... */
#define KEYFUNC_NODE_MESSAGE      (CHAR_OPCODE|(0x0f00))
#define KEYFUNC_SYSCHAT_FS        (CHAR_OPCODE|(0x0e00))
#define KEYFUNC_SYSCHAT_LINE      (CHAR_OPCODE|(0x0d00))
#define KEYFUNC_NO_CARRIER        (CHAR_OPCODE|(0x0c00))
#define KEYFUNC_NO_OPERATION      (CHAR_OPCODE|(0x0fff))

/* User keyfuns, caused by pressing a key... */
#define KEYFUNC_CURSOR_UP         (CHAR_OPCODE|('E'-64))
#define KEYFUNC_CURSOR_DOWN       (CHAR_OPCODE|('X'-64))
#define KEYFUNC_CURSOR_LEFT       (CHAR_OPCODE|('S'-64))
#define KEYFUNC_CURSOR_RIGHT      (CHAR_OPCODE|('D'-64))

#define KEYFUNC_WORD_LEFT         (CHAR_OPCODE|('A'-64))
#define KEYFUNC_WORD_RIGHT        (CHAR_OPCODE|('F'-64))

#define KEYFUNC_PAGE_UP           (CHAR_OPCODE|('R'-64))
#define KEYFUNC_PAGE_DOWN         (CHAR_OPCODE|('C'-64))

#define KEYFUNC_HOME              (CHAR_OPCODE|(0x0400)) /* 'J'-64 */
#define KEYFUNC_END               (CHAR_OPCODE|('G'-64))

#define KEYFUNC_ENTER             (CHAR_OPCODE|('M'-64))
#define KEYFUNC_TAB               (CHAR_OPCODE|('I'-64))
#define KEYFUNC_ESCAPE            (CHAR_OPCODE|(0x001b))

#define KEYFUNC_SAVE              (CHAR_OPCODE|('Z'-64))
#define KEYFUNC_ABORT             (CHAR_OPCODE|('Q'-64))

#define KEYFUNC_DELETE_CHAR       (CHAR_OPCODE|(0x007f))
#define KEYFUNC_BACK_SPACE        (CHAR_OPCODE|('H'-64))

#define KEYFUNC_DELETE_WORD       (CHAR_OPCODE|('T'-64))
#define KEYFUNC_DELETE_LINE       (CHAR_OPCODE|('Y'-64))

#define KEYFUNC_INSERT_LINE       (CHAR_OPCODE|('O'-64))
#define KEYFUNC_UNDO_DEL_LINE     (CHAR_OPCODE|('B'-64))
#define KEYFUNC_HELP              (CHAR_OPCODE|('U'-64))

#define KEYFUNC_QUOTE_LINE        (CHAR_OPCODE|('W'-64))
#define KEYFUNC_REDRAW            (CHAR_OPCODE|('N'-64))

#define KEYFUNC_MENU              (CHAR_OPCODE|('K'-64))
#define KEYFUNC_JUSTIFY           (CHAR_OPCODE|('P'-64))

#define KEYFUNC_TOGGLE_XY_DISP    (CHAR_OPCODE|('L'-64))
#define KEYFUNC_TOGGLE_INSERT     (CHAR_OPCODE|(0x0200))
#define KEYFUNC_TOGGLE_INDENT     (CHAR_OPCODE|(0x0300))
#define KEYFUNC_TOGGLE_INSIND     (CHAR_OPCODE|('V'-64))

/* Menu keyfuncs... (or special editor keys..) */
#define KEYFUNC_CHANGE_SUBJECT    (CHAR_OPCODE|(0x0040))
#define KEYFUNC_DELETE_REST       (CHAR_OPCODE|(0x0041))
#define KEYFUNC_GOTO_LINE         (CHAR_OPCODE|(0x0042))
#define KEYFUNC_DELETE_N_LINES    (CHAR_OPCODE|(0x0043))
#define KEYFUNC_MARK_POSITION     (CHAR_OPCODE|(0x0044))
#define KEYFUNC_GOTO_MARK         (CHAR_OPCODE|(0x0045))
#define KEYFUNC_DELETE_FROM_MARK  (CHAR_OPCODE|(0x0046))
#define KEYFUNC_INSERT_FILE       (CHAR_OPCODE|(0x0047))
#define KEYFUNC_TOGGLE_TAB_MOVES  (CHAR_OPCODE|(0x0048))
#define KEYFUNC_TOGGLE_AUTOINDENT (CHAR_OPCODE|(0x0049))
#define KEYFUNC_SET_WORD_WRAP     (CHAR_OPCODE|(0x004a))
#define KEYFUNC_ASK_WORD_WRAP     (CHAR_OPCODE|(0x004b))

#define KEYFUNC_UNUSED_1          (CHAR_OPCODE|(0x004c))
#define KEYFUNC_UNUSED_2          (CHAR_OPCODE|(0x004d))
#define KEYFUNC_UNUSED_3          (CHAR_OPCODE|(0x004e))



/* COLORS */
#define COL_BLACK         0x00
#define COL_RED           0x01
#define COL_GREEN         0x02
#define COL_YELLOW        0x03
#define COL_BLUE          0x04
#define COL_MAGENTA       0x05
#define COL_CYAN          0x06
#define COL_WHITE         0x07
#define COL_BRIGHT        0x08

/* WHO DEFINES */
#define WHO_LOGOFF        0x00
#define WHO_ACTIVE        0x01
#define WHO_NOTAVAIL      0x02
#define WHO_ENTERING      0x03
#define WHO_GRABBING      0x04
#define WHO_DOWNLOAD      0x05
#define WHO_UPLOAD        0x06
#define WHO_SYSCHAT       0x07
#define WHO_INDOOR        0x08
#define WHO_GROUPCHAT     0x09
#define WHO_COMMENTING    0x0a
#define WHO_BROWSINGFILES 0x0b
#define WHO_NEWFILES      0x0c


/* MODEM ERROR CORRECTIONS */
#define EC_NONE           0x00
#define EC_UNKNOWN        0x01  /* Error correction, but method unknown */
#define EC_MNP            0x02
#define EC_V42            0x03

/* TERMINALS */
#define TERM_TTY          0x00
#define TERM_ANSI         0x01
#define TERM_VT100        0x02
#define TERM_AVATAR       0x03
#define TERM_RIPTERM      0x04

/* KEYMAPS */
#define KEYMAP_IBM        0x00
#define KEYMAP_SF7        0x01
#define KEYMAP_ISO        0x02
#define KEYMAP_MAC        0x03

/* MSG HEADERS */
#define MSGHFULL          0x00
#define MSGHMED           0x01
#define MSGHTINY          0x02

/* MSG READING DIRECTIONS */
#define FORWARD           0x00
#define REFERENCE         0x01


/* USER SETABLE COLORS */
#define PAL_BACKGROUND ((User.Palette.Palette[0] & 0x0f)>>0)  /* 01 */
#define PAL_MAINCMD    ((User.Palette.Palette[0] & 0xf0)>>4)  /* 02 */
#define PAL_READCMD    ((User.Palette.Palette[1] & 0x0f)>>0)  /* 03 */
#define PAL_FILECMD    ((User.Palette.Palette[1] & 0xf0)>>4)  /* 04 */
#define PAL_DANGER     ((User.Palette.Palette[2] & 0x0f)>>0)  /* 05 Dangerous commands */
#define PAL_OFFLINE    ((User.Palette.Palette[2] & 0xf0)>>4)  /* 06 Not set. */

#define PAL_EDITOR1    ((User.Palette.Palette[3] & 0x0f)>>0)  /* 07 Editor text        */
#define PAL_EDITOR2    ((User.Palette.Palette[3] & 0xf0)>>4)  /* 08 Infos              */
#define PAL_MSGTEXT    ((User.Palette.Palette[4] & 0x0f)>>0)  /* 09 Message text       */
#define PAL_QUOTES     ((User.Palette.Palette[4] & 0xf0)>>4)  /* 10 Quote color        */
#define PAL_OWNNAME    ((User.Palette.Palette[5] & 0x0f)>>0)  /* 11 Own name in messages */
#define PAL_OTHERNAMES ((User.Palette.Palette[5] & 0xf0)>>4)  /* 12 Others names       */

#define PAL_DEFTEXT    ((User.Palette.Palette[6] & 0x0f)>>0)  /* 13 */
#define PAL_CHEADER    ((User.Palette.Palette[6] & 0xf0)>>4)  /* 14 */
#define PAL_NODEMSGS   ((User.Palette.Palette[7] & 0x0f)>>0)  /* 15 */
#define PAL_AREANAME   ((User.Palette.Palette[7] & 0xf0)>>4)  /* 16 Confname at messagemenu/filemenu */

#define PAL_NAFILE     ((User.Palette.Palette[8] & 0x0f)>>0)  /* 17 Unavailable file */
#define PAL_FREEFILE   ((User.Palette.Palette[8] & 0xf0)>>4)  /* 18 */
#define PAL_PRIVFILE   ((User.Palette.Palette[9] & 0x0f)>>0)  /* 19 */
#define PAL_FILENAMES  ((User.Palette.Palette[9] & 0xf0)>>4)  /* 20 Filenames */
#define PAL_DESCS      ((User.Palette.Palette[10] & 0x0f)>>0) /* 21 Descriptions */
#define PAL_CMDLINE    ((User.Palette.Palette[10] & 0xf0)>>4) /* 22 */
#define PAL_ERROR      ((User.Palette.Palette[11] & 0x0f)>>0) /* 23 */
#define PAL_MSGHEADERC ((User.Palette.Palette[11] & 0xf0)>>4) /* 24 */
#define PAL_SUBJECT    ((User.Palette.Palette[12] & 0x0f)>>0) /* 25 */
#define PAL_MSGEDIT    ((User.Palette.Palette[12] & 0xf0)>>4) /* 26 */
#define PAL_HELPTEXT   ((User.Palette.Palette[13] & 0x0f)>>0) /* 27 */
#define PAL_HELPKEYW   ((User.Palette.Palette[13] & 0xf0)>>4) /* 28 */
#define PAL_DESC1STLIN ((User.Palette.Palette[14] & 0x0f)>>0) /* 29 */

#define PAL_FILESTATS  ((User.Palette.Palette[14] & 0xf0)>>4) /* 30 */
#define PAL_FILEAREAS  ((User.Palette.Palette[15] & 0x0f)>>0) /* 31 */
#define PAL_UNUSEDPAL  ((User.Palette.Palette[15] & 0xf0)>>4) /* 32 */




#define CL_DEFAULT       (CL_HISTORY | CL_SAVEHISTORY | CL_NEWLINE)
#define CL_FILELISTFLAG  (CL_HISTORY | CL_SAVEHISTORY)

#define CL_NONE          0x0000
#define CL_HISTORY       0x0001
#define CL_SAVEHISTORY   0x0002
#define CL_NEWLINE       0x0004  /* Only when field ?? */
/*#define CL_SPECIALLINE   0x0008  / --- removed... (''Added */
#define CL_NUMBERS       0x0010
#define CL_NONODEMSG     0x0040
#define CL_SHOWAREA      0x0080  /* Edit, eh? */


typedef unsigned short USERNUMBER; /* User, (usergroup 65501 to 65533) */

typedef unsigned short CONFNUMBER; /* Conference number 0x000-0xfff */
typedef unsigned short MSGNUMBER;  /* Message number in conference */

typedef unsigned short AREANUMBER; /* FileArea */
typedef unsigned short FILENUMBER; /* FileNumber in files.dat */
typedef unsigned short FILEFLAG;   /* FileFlag */
typedef unsigned short FLAGNUMBER; /* Number of file flag */



typedef union {
  unsigned char  *pUChar;
  unsigned short *pUShort;
  unsigned long  *pULong;
  unsigned long   ULong;
} VBX_REGISTER;


typedef struct {
  unsigned char  Key;
  unsigned char  ScriptName[8+1+3+1];
} HOOK_KEY;


typedef struct {
  unsigned char *Name;
  unsigned char  Type;
  unsigned char  MaxStringLen; /* For internal variables only! */
  void          *Value;
} INTVARIABLE;


/* VBasic variable types */
#define VARIABLE_INTERNAL       0x80 /* Internal variable, do not free ... */
#define VARIABLE_READONLY       0x40 /* Not allowed to change ... */
#define VARIABLE_ARRAY          0x20 /* Array... Not yet used */
#define VARIABLE_RESV           0x10 /* Reserved for future use ... */

/* VARIABLE_INT is 16bit if 16Bit DOS version, otherwise 32bit ... */
#if defined(__MSDOS__) && defined(__BORLANDC__)
#define VARIABLE_INT            0x03
#else
#define VARIABLE_INT            0x04
#endif

#define VARIABLE_UNUSED         0x00
#define VARIABLE_STRING         0x01
#define VARIABLE_CHAR           0x02
#define VARIABLE_SHORT          0x03
#define VARIABLE_LONG           0x04

#define VARIABLE_FILEPTR        0x05

#define VARIABLE_FUNCTION       0x0c
#define VARIABLE_SUB            0x0e
#define VARIABLE_LABEL          0x0f


#define VARIABLE_CHAR_R         (VARIABLE_CHAR | VARIABLE_READONLY)
#define VARIABLE_SHORT_R        (VARIABLE_SHORT | VARIABLE_READONLY)
#define VARIABLE_INT_R          (VARIABLE_INT | VARIABLE_READONLY)
#define VARIABLE_LONG_R         (VARIABLE_LONG | VARIABLE_READONLY)
#define VARIABLE_STRING_R       (VARIABLE_STRING | VARIABLE_READONLY)

#define FileVariable(x)         (((x) & 0x0f)==VARIABLE_FILEPTR)
#define LabelVariable(x)        (((x) & 0x0f)==VARIABLE_LABEL)
#define StringVariable(x)       (((x) & 0x0f)==VARIABLE_STRING)
#define NumericVariable(x)      (((x) & 0x0f)>=VARIABLE_CHAR && ((x) & 0x0f)<=VARIABLE_FILEPTR)



typedef struct {
  unsigned short MsgNum;
  unsigned short Flags;
  unsigned short Size;
} ERR_MSG_ENTRY;


/* General category ... */
#define ERRMSG_NOERROR          0x00 /* No error ... */
#define ERRMSG_USAGE            0x01 /* No node number ... */
#define ERRMSG_NOPOSTCONF       0x02 /* No post conference ... */
#define ERRMSG_INVALID_ARG      0x04 /* Invalid parameter ... */

/* Initialization ... */
#define ERRMSG_LOAD_KEYMAP      0x10 /* Can't load default keymap ... */
#define ERRMSG_INIT_NODEMSG     0x11 /* Can't create node message file ... */
#define ERRMSG_INIT_WHO         0x12
#define ERRMSG_INIT_VBOARD      0x13 /* Unused!! */

/* Registeration code ... */
#define ERRMSG_BAD_LICENSE      0x20 /* Bad registeration code ... */
#define ERRMSG_NO_LINE_NODES    0x21 /* Not enought nodes ... */
#define ERRMSG_NO_LOCAL_NODES   0x22
#define ERRMSG_UNREG_ONLY_1     0x23 /* Unregistered can only use node 1 ... */

/* KBD thread ... */
#define ERRMSG_NODE_ACTIVE      0x30
#define ERRMSG_KBD_SEM          0x31 /* Can't create KBD semaphore ...*/
#define ERRMSG_KBD_THREAD       0x32 /* Can't create KBD thread ... */

/* COM thread ... */
#define ERRMSG_COM_SEM          0x40 /* Can't create COM semaphore ... */
#define ERRMSG_COM_THREAD       0x41 /* Can't create COM thread ... */
#define ERRMSG_COM_MUXWAIT      0x42 /* AddMuxWait ... */

/* COM prot opening and reset ... */
#define ERRMSG_COMOPEN_NOCOM    0x50 /* No com port ... */
#define ERRMSG_COMOPEN_INUSE    0x51 /* Com port already in use ... */
#define ERRMSG_COMOPEN_UNKNOWN  0x52 /* Unknown error ... */
#define ERRMSG_COMOPEN_DCB      0x53 /* Win32 BuildComDCB error ... */
#define ERRMSG_COMOPEN_BUFFS    0x54 /* Failed to allocate buffers ... */
#define ERRMSG_COMOPEN_NOFOSSIL 0x55 /* No fossil driver detected ... */

/* File open ... */
#define ERRMSG_FOPEN_NOFILE     0x60 /* File does not exist ... */
#define ERRMSG_FOPEN_TOOMANY    0x61 /* Too many open files .. */

/* Exceptions ... */
#define ERRMSG_MEMORYPROT       0xf0
#define ERRMSG_MEMORYPROT_VB    0xf1


typedef struct {
  unsigned short ID;
  unsigned short x;
  unsigned short y;
  unsigned long  SigNum;
  unsigned char  Reserved[64];
} SIGERR_HDR;


typedef struct {
  unsigned char  *Buffer;
  unsigned int    BufSize;
} HISTORY;



#define PACKER_UNKNOWN   0x00
#define PACKER_ARC       0x01
#define PACKER_ZOO       0x02
#define PACKER_LZH       0x03
#define PACKER_ZIP       0x04
#define PACKER_ARJ       0x05
#define PACKER_RAR       0x06
#define PACKER_SFX       0xff

typedef struct {
  unsigned short Count;             /* Internal variable, do not change! */
  unsigned char  Name[256];         /* Packet file name */
  unsigned long  PackedSize;        /* Size packed */
  unsigned long  OriginalSize;      /* Size unpackked */
  unsigned char  Method[16];        /* Inflated, ARJ/M1, etc */
  unsigned long  FileCRC;           /* File CRC value. Assumed 32 bit */
  unsigned char  Day, Month, Year;  /* File date */
  unsigned char  Min, Hour;         /* File time */
} PACKED_FILE;


typedef struct {
  unsigned short From;
  unsigned short To;
} MSGRANGE;


typedef struct {            /* Takes only 5 chars */
  unsigned char Day;
  unsigned char Month;
  unsigned char Year;
  unsigned char Min;
  unsigned char Hour;
} LDATE;


typedef struct {                /* Takes only 3 chars */
  unsigned char Day;
  unsigned char Month;
  unsigned char Year;
} SDATE;


typedef struct {
  unsigned short Zone;
  unsigned short Net;
  unsigned short Node;
} NETADDR;


typedef struct {
  unsigned short Zone;
  unsigned short Net;
  unsigned short Node;
  unsigned char  Point;
} NETADDRPOINT;


typedef struct {
  unsigned long  Mystic;            /* VBOARD.DAT */
  unsigned short SerNum;
  unsigned char  Versio[64];
  unsigned char  RegisteredTo[NAMELEN];
  unsigned char  Reserved[128];
} VBOARDDAT;


typedef struct {
  unsigned char  LastCaller[NAMELEN];     /* Statistiikka */

  unsigned short Callers;                 /* Total number of callers.      */
  unsigned short NewMessages;             /* Total messages entered.       */
  unsigned short NewMessagesToSysOp;      /* Messages for SysOp.           */
  unsigned short MessagesRead;            /* Total messages read.          */
  unsigned short Uploads;                 /* Files uploaded.               */
  unsigned long  UploadedBytes;           /* Bytes uploaded.               */
  unsigned short Downloads;               /* Files downloaded.             */
  unsigned long  DownloadedBytes;         /* Bytes downloaded.             */

  unsigned short SecondsFree;             /* Time spent for waiting caller.*/
  unsigned short SecondsUsed;             /* Time spent serving caller.    */

  time_t         StartFree;               /* Internal variable, do not use.*/
  time_t         StartUsed;               /* Internal variable, do not use.*/

/*unsigned short  TotalCallers=FALSE;
  unsigned short  MessagesLeft=FALSE;
  unsigned short  MessagesRead=FALSE;
  unsigned short  FilesUploaded=FALSE;
  unsigned short  FilesDownloaded=FALSE;*/
} SYSTEM_STATS;

/* Typedef ASKSTR_CTRL:
 * ======================================================================
 * Internal datatype used to pass information between AskString
 * functions.
 *
 *
 */
typedef struct {
  unsigned int   PromptLine;
  unsigned int   PromptLen;
  unsigned char *Line;
  unsigned int   LineLen;
  unsigned char *NextLine;
  unsigned char *SpecialWord;
  unsigned char *RestOfLine;
  unsigned int   SpecialColor;
  unsigned int   MaxLen;
  unsigned int   Options;
  unsigned int   i;
} ASKSTR_CTRL;


typedef struct {
  unsigned char Palette[16];
} PALETTE;


typedef struct {
  unsigned char  Name[NAMELEN];
  unsigned short Attributes;            /* More attributes */

    signed char  GroupTimeModify[32];
  unsigned char  OwnDlCreditModify[32];
  unsigned char  AllDlCreditModify[32];

  unsigned short GroupMaxCredits[32];
  unsigned short GroupDailyAdd[32];
} GROUP;


/* VBoard<Ctrl+Z>
 * ConfigRev..
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 */



/***************************************************************************
 * VBoard global config file format.
 *
 * Improvements to make in next vboard.cfg change.
 * ===================================================================
 * * Change all passwords to extra security MD5 passwords.
 * * Add configuration password.
 * + Add more CDrom drives.
 * + Get rid of protocol names.
 * + Reorganize group settings to one internal structure.
 *
 */

typedef struct {
  unsigned char  BBSName[41];             /* Name of the BBS. */
  unsigned char  SysOpName[NAMELEN];      /* SysOps name. Comments. */

  unsigned char  SystemPass[13];          /* Will be changed to MD5. */
  unsigned char  NewUserPass[13];         /* Will be changed to MD5. */

  unsigned char  ShellPass[13];           /* Obsolite */
  unsigned char  UEditPass[13];           /* Obsolite */
  unsigned char  ShellExec[48];           /* Obsolite */

  #define GBIT_MESSAGECOMPRESSION  0x01
  #define GBIT_SYSCHAT_LOG         0x02
  #define GBIT_GRPCHAT_LOG         0x04
  unsigned char  GBitToggles;             /* Global bittogles ... */
  unsigned char  QWKName[9];              /* QWK packet name. */
  unsigned char  OmenId[3];               /* Omen ID bytes. */

  /* Group settings */
    signed char  GroupTimeModify[32];     /* Modify member time limit */
  unsigned short GroupMaxCredits[32];     /* Add limit */
  unsigned short GroupDailyAdd[32];       /* Add x credits per day called */
  unsigned char  GroupDlCreditModify[32]; /* Credit modify percent */

  unsigned char  Custom1PName[11];
  unsigned char  Custom2PName[11];
  unsigned char  Custom3PName[11];
  unsigned char  Custom4PName[11];
  unsigned char  Custom5PName[11];
  unsigned char  Custom6PName[11];

  unsigned char  UnUsed1[54];             /* Free bytes, zeroed.. */
  unsigned char  CDROM_Drives[6];         /* CD-ROM drives: "EFG". */

  /* Group settings II */
  unsigned char  GroupName[32][NAMELEN];  /* Group names. */
  unsigned char  GroupType[32];           /* Group atributes, GRP_xxxx. */

  unsigned char  Macro[10][51];           /* Alt+1-0 macros. */
  unsigned short UploadArea;              /* Upload area number, internal */

  unsigned long  RegCode1;                /* 11111122-xxxxxxx.... */
  unsigned long  RegCode2;                /* xxxxxxxx-1333245-xxxx... */
  unsigned long  RegCode3;                /* Etc... */
  unsigned long  RegCode4;                /* Etc... */
  unsigned char  RegName[NAMELEN];        /* xxxx-John Doe */
} GCONFIG;


typedef struct {
  /* General */
  unsigned char  FieldColor;
  unsigned char  PollRate;
  unsigned short WaitingSleep___;
  unsigned char  SysOpChatColor;
  unsigned char  UserChatColor;
  unsigned char  AskSotuTimes; /* Times to allow re-enter sotu.. */
  unsigned char  NCOpt1;

  #define NCOPT1_UNUSED         0x01
  #define NCOPT1_SHOWEMPTYNODES 0x02
  #define NCOPT1_ALLOWSYSKEYS   0x04
  #define NCOPT1_SHOWNEWFILES   0x08
  #define NCOPT1_KILLEMPTYLINES 0x10
  #define NCOPT1_ALLOWNEWUSERS  0x20
  #define NCOPT1_ALLOWSAMEALIAS 0x40

  /* OS/2 Priority stuff */
  unsigned char  Pri_ComThread;    /* Reading serial port ... */
  unsigned char  Pri_KbdThread;    /* Reading local keyboard ... */
  unsigned char  Pri_NMsgThread;   /* Nodemessage thread ... */
  unsigned char  Pri_DefaultMain;  /* Default main thread priority ... */
  unsigned char  Pri_FileScans;    /* Search, newfilelists, ect ... */
  unsigned char  Pri_OffLnDload;   /* Offline packet downloads ... */
  unsigned char  Pri_unused1;
  unsigned char  Pri_unused2;

  /* Modem */
  unsigned char  ModemInit[40]; /* Modem initialization string.            */
  unsigned char  ModemBusy[20]; /*                                         */
  unsigned char  ExitFree[20];  /*                                         */
  unsigned char  ExitBusy[20];  /*                                         */
  unsigned char  FaxCommand[60];/*                                         */
  unsigned char  DeviceName[40];/* Reserved for future expansion.          */

  unsigned long  StartBaud;     /* Modem initialization speed.             */
  unsigned char  ComPort;
  unsigned char  IRQ;           /* Dos only. If nonzero int. ASYNC is used */
  unsigned char  ModemOpts;

  #define MODEMOPT_RESETSPEED   0x01
  #define MODEMOPT_RTSCTS       0x02
  #define MODEMOPT_HANGUP       0x04
  #define MODEMOPT_DTRHANGUP    0x08
  #define MODEMOPT_RUNFAXVMD    0x10

  /* Directories */
  unsigned char  BBSDir[40];    /*                                         */
  unsigned char  MainDir[40];   /*                                         */
  unsigned char  MenuDir[40];   /*                                         */
  unsigned char  PackDir[40];   /* Used for packking messages              */
  unsigned char  TempUp[40];    /*                                         */
  unsigned char  HoldDir[40];   /* Used ONLY for extracting files          */
  unsigned char  NodeDir[40];   /* Directory for who and nodemessages      */
  unsigned char  FileDir[40];   /* Obsolite, but still hanging on.         */

  /* Files */
  unsigned short WarnHDSpace;   /* Warn uploaders if less space...         */
  unsigned short DenyUpHDSpace; /* Deny uploading if less space...         */
  unsigned char  NCOpt2;
  #define NCOPT2_USEFILEIDDIZ   0x01
  #define NCOPT2_DISABLE_EMSI   0x02
  #define NCOPT2_NO_LLOGINS     0x04

  /* CreditSystem */
  unsigned short FullCreditsMaxDays;
  unsigned short NoCreditsDays;
  unsigned char  Extensions[16][4];
  unsigned short ExtensionModify[16];
  unsigned short Credit1Lim;
  unsigned short Credit2Lim;
  unsigned short Credit3Lim;
  unsigned char  Credit1Mul10;
  unsigned char  Credit2Mul10;
  unsigned char  Credit3Mul10;
  unsigned char  Credit4Mul10;

  unsigned char  CredOpts;
  #define CREDITOPT_USECREDITS  0x01



  /* New users */
  unsigned short NewUserTime;
  unsigned short NewUserCredits;
  PALETTE        Palette;

  unsigned char  ChatOpts;
  #define CHATOPT_ALLOWCOLORSCHANGES 0x01
  #define CHATOPT_EQUALSIZECHAT   0x02
  #define CHATOPT_ALLOWUSEREXIT   0x04


  unsigned char  Reserved[292];

  unsigned long  NewUserAFlags;          /* Access flags; up, down, doors etc.    */
  unsigned long  NewUserSFlags;          /* Status flags; NewUser, Favoured etc.  */
  unsigned long  NewUserGFlags;          /* General option flags.                 */
  unsigned long  NewUserBFlags;          /* General option flags.                 */
  unsigned long  NewUserRFlags;          /* Run script flags.                     */
  unsigned long  NewUserCFlags;          /* Control flags.                        */
  unsigned long  NewUserMFlags;          /* Message option flags.                 */
  unsigned long  NewUserFFlags;          /* File option flags.                    */
  unsigned long  NewUserOFlags;          /* Offline option flags.                 */
  unsigned long  NewUserEFlags1;         /* Extra flags.                          */
  unsigned long  NewUserEFlags2;         /* Extra flags.                          */
  unsigned long  NewUserEFlags3;         /* Extra flags.                          */
  unsigned long  NewUserEFlags4;         /* Extra flags.                          */
} NCONFIG;

typedef struct {
  unsigned long  MinBps;        /* Min speed to allow user to login.       */

  unsigned short MaxTimeLim;    /* Rush limit for normal users.            */
  unsigned short FavMaxTimeLim; /* Rush limit for favoured users.          */
    signed short TimeModify;    /* Time modify for normal users.           */
    signed short FavTimeModify; /* Time modify for favoured users.         */

  unsigned short MaxDlTime;     /* Max time allowed for downloading.       */
  unsigned short MaxTimeUsage;  /* Absolute maximum time usage.            */

  unsigned char  RushOptions;
  #define RUSHOPT_NOGROUPCHAT        0x01
} RUSHLIMIT;


typedef struct {
  unsigned short From;
  unsigned short To;
} HRANGE;


typedef struct {
  RUSHLIMIT      RushLimitData[8];  /* 8 rushlimit settings.                   */
  HRANGE         RushLimit[8][7*3];
  HRANGE         AnswerPhone[7*3];  /* Typical night BBS: 00:00-06:00, 21:00-24*/
  HRANGE         NormalYell[7*3];   /*                                         */
  HRANGE         FavouredYell[7*3]; /*                                         */
  HRANGE         Reserved1[7*3];
  HRANGE         Reserved2[7*3];
} RANGES;



/* "LOGINMSG.DAT" */


#define LMSG_LASTCALLER         0x00
#define LMSG_MESSAGE            0x01
#define LMSG_FILEDELETED        0x02
#define LMSG_CREDITSTAKEN       0x03

/*****************************************************************************
Message from Vesa Suonp
* 1xCredits has been taken from file PASKAA.ZIP. 9759 credits lost!
  Note: Fileiss on jo uudempi versio!


SysOp has taken File PASKAA.ZIP deleted,



*/


typedef struct {
  unsigned short LMsgType;
  unsigned short LifeTime;
  unsigned short MsgTo;
  unsigned short MsgFrom;
  unsigned char  MsgFromName[NAMELEN];
  time_t         MsgDate;       /* Same message if within 10 min from prev.*/
  unsigned char  Reserved[32];
} LMSG_COMMON;                  /* Total 47 bytes                          */


typedef union {
  LMSG_COMMON    Common;
  unsigned char  Padding[256];

  struct {
    LMSG_COMMON    Common;
    time_t         LogIn;
    time_t         LogOut;
    unsigned long  ModemSpeed;
    unsigned char  ErrorCorrection;
    unsigned short Node;
  } LastCaller;

  struct {
    LMSG_COMMON    Common;
    unsigned char  Text[80]; /* Max 79 chars per line */
  } Message;

  struct {
    LMSG_COMMON    Common;
    unsigned char  FileName[51];
    unsigned char  CreditsTakenMultiply;
    unsigned short CreditsTaken;
    unsigned char  Note[80];
  } CreditsTaken;

} LMSG;












/***************************************************************************
 * VBoard Packer configuration. Versions 2.20 =>
 *
 * Improvements to make in next packer configuration change.
 * ===================================================================
 */

typedef struct {
  unsigned char  IntViewFunc;   /* Internal view function number.          */
  unsigned char  Name[20];      /* Packer name                             */
  unsigned char  Command[20];   /* Set command to select packer.           */

  unsigned char  Extension[4];  /*                                         */
  unsigned char  MultiVExt[4];  /*                                         */
  unsigned char  IdBytes[32];   /* String used to identify the packer      */

  unsigned char  PackExec[40];  /* Execution string to pack files.         */
  unsigned char  UnPackExec[40];/* Execution string to extract files.      */
  unsigned char  DeleteExec[40];/* ... to delete files from packets.       */
  unsigned char  CommentExec[40];/* .. to change packet comment.           */
  unsigned char  TestExec[40];  /* ... to test archive integrity.          */
  unsigned char  VirusExec[40]; /* ... to test if infected.                */

  unsigned char  Reserved[64];  /* Reserved for future expansion.          */

  unsigned char  Flags;
  #define PACKFLAG_PACKINVMD      0x01
  #define PACKFLAG_UNPACKINVMD    0x02
  #define PACKFLAG_DELETEINVMD    0x04
  #define PACKFLAG_COMMENTINVMD   0x08
  #define PACKFLAG_TESTINVMD      0x10
  #define PACKFLAG_VIRUSTESTINVMD 0x20
} PACKER;


/***************************************************************************
 * VBoard internal archive view structure. For internal use only!
 */

typedef struct {
  unsigned char  IntViewFunc;   /* Internal view function number */
  unsigned long  Eof;

  unsigned char  Arch_day;      /* Archive date */
  unsigned char  Arch_month;
  unsigned char  Arch_year;
  unsigned char  Arch_hour;
  unsigned char  Arch_min;

  unsigned char  Name[256];     /* Packed file name */
  unsigned long  SizePacked;    /* File size in packet */
  unsigned long  SizeUnPacked;
  unsigned char  MethodName[32];

  unsigned char  File_day;
  unsigned char  File_month;
  unsigned char  File_year;
  unsigned char  File_hour;
  unsigned char  File_min;

  unsigned long  Crc32;         /* File CRC.. even if CRC16. */
} VIEW;


typedef struct {
  unsigned char *ArqString;
  unsigned char *WorkingDir;
  unsigned char *Environment;
  unsigned char *FileNames;
  unsigned char *PacketName;
  unsigned int   ExecuteInVDM;  /* True if DOS program */
  unsigned char *SessionTittle; /* Session tittle, toggles if use process */
  unsigned char *VDMSettingsFile;
  unsigned int   Wait;
  unsigned int   Indipendent;
} EESTART;



/***************************************************************************
 * VBoard Protocol configuration format. Versions 2.20 =>
 *
 * Improvements to make in next protocol configuration change.
 * ===================================================================
 */
typedef struct {
  unsigned char  Name[20];      /* Protocol name.                          */
  unsigned char  Command[20];   /* Set command to select proctocol.        */

  unsigned char  Upload[120];
  unsigned char  Download[120];
  unsigned char  UseDSZLog;
  unsigned char  UnUsed[59];

  unsigned char  SettingsFile[13];      /* DOS Box settings */
  unsigned char  FileSeparator;
  unsigned char  GRUpload;
  unsigned char  GRDownload;
  unsigned char  Effiency;
  unsigned char  Reserved[6];           /* Reserved for future expansion */

  unsigned char  Flags1;
  unsigned char  Flags2;

  #define PROTFLAG1_ALLOWUPLOAD     0x01
  #define PROTFLAG1_ALLOWDOWNLOAD   0x02
  #define PROTFLAG1_BIDIRECTIONAL   0x04
  #define PROTFLAG1_ALLOWBATCH      0x08
  #define PROTFLAG1_CLOSECOM        0x10
  #define PROTFLAG1_ASKFORNAME      0x20
  #define PROTFLAG1_USELISTFILE     0x40
  #define PROTFLAG1_EXECUTEASVDM    0x80

  #define PROTFLAG2_REMOVESFAILED   0x01
  #define PROTFLAG2_CWDTOTEMPUP     0x02
} PROTOCOL;


typedef struct {
  unsigned char  Name[NAMELEN];
  unsigned char  EventExec[57];
  unsigned short ExecTime;

  unsigned char  RunDays;
  #define EVENTRUN_MONDAY         0x01
  #define EVENTRUN_TUESDAY        0x02
  #define EVENTRUN_WEDNESDAY      0x04
  #define EVENTRUN_THURSDAY       0x08
  #define EVENTRUN_FRIDAY         0x10
  #define EVENTRUN_SATURDAY       0x20
  #define EVENTRUN_SUNDAY         0x40
  #define EVENTRUN_EXECUTETODAY   0x80
  SDATE          LastRun;

  unsigned char  EventFlags;
  #define EVENTFLAGS_EXECASPROCESS  0x01
  #define EVENTFLAGS_EXECUTEASVDM   0x02
  #define EVENTFLAGS_EXITAFTERSTART 0x04

  unsigned char Reserved[124];
} EVENT;


typedef struct {                  /* Version 1.17/Rev A change!            */
  NETADDRPOINT   Own;
  NETADDRPOINT   Hub;
/*
  unsigned short OwnZone;
  unsigned short OwnNet;
  unsigned short OwnNode;

  unsigned short HubZone;
  unsigned short HubNet;
  unsigned short HubNode;
*/
} AKAREC;





/***************************************************************************
 * VBoard Users.dat file format. Versions 3.00 =>
 *
 * Improvements to make in next users.dat change.
 * ===================================================================
 * + Add CRC32 to the begining of user record. Checks if users.das has
 *   been changed with some hacking tool.
 * + Add DailyDownloadLimit, DailyDownloadLimitLeft.
 * * Add ID field that shows user record version.
 * + Add kicked off untill time_t (date). Can't login before date.
 * + Add kick off after time_t (date). Can't login after date.
 * * Add more SysOp bits, including SYS_USERINFO (allows to see user data),
 *   SYS_LOGS (allows to see logs)
 *
 */

typedef struct {
  /* User strings =(=======================================================*/
  unsigned char  Name[NAMELEN];   /* User name                             */
  unsigned char  Alias[NAMELEN];  /* User Alias                            */
  unsigned char  Address[30];     /* User address                          */
  unsigned char  ZipCode[10];     /* Zip code                              */
  unsigned char  City[30];        /* User City                             */
  unsigned char  Phone[26];       /* User Phone                            */
  unsigned char  Occup[30];       /* Occupation                            */
  unsigned char  EMail[45];       /* Internet mail address.                */
  unsigned char  Custom1[30];     /* (Machine type)                        */
  unsigned char  Custom2[30];     /* (Suosittelijat..)                     */
  unsigned char  Custom3[30];     /*                                       */
  unsigned char  Custom4[30];     /*                                       */
  unsigned char  Custom5[30];     /*                                       */
  unsigned char  Custom6[15];     /*                                       */
  unsigned char  Pass[16];        /* Password, encrypted.                  */

  /* User limits ==========================================================*/
  unsigned short TimeLimit;       /* User timelimit in minutes             */
  unsigned short TimeUsedToday;   /* Time used today in minutes.           */
    signed short SysTimeModify;   /* Extra time given or taken for today   */
    signed long  FileCredits;     /* Users file credits                    */
  unsigned short ResumeNumber;    /* Reserved for future use               */
  unsigned short TimeInBank;      /* Reserved for timebank                 */
  unsigned short TimeWthdrwnToday;/* Reserved for timebank                 */
  unsigned short DailyDlLimit;    /* Reserved for future use               */
  unsigned short DailyFileDlLimit;/* Reserved for future use               */
  unsigned short Reserved_S1;     /* Reserved for future use               */
  unsigned short Reserved_S2;     /* Reserved for future use               */
  unsigned short Reserved_S3;     /* Reserved for future use               */
  unsigned short Reserved_S4;     /* Reserved for future use               */
  unsigned short Reserved_S5;     /* Reserved for future use               */
  unsigned short Reserved_S6;     /* Reserved for future use               */

  /* User stats ===========================================================*/
  unsigned short TotalCalled;     /* Total times called                    */
  unsigned short MessagesLeft;    /* Total messages entered or uploaded    */
  unsigned long  MessagesRead;    /* Messages read online                  */
  unsigned long  MessagesDump;    /* Messages downloaded with OMEN/QWK     */
  unsigned short FilesUploaded;   /* Number of files uploaded              */
  unsigned short FilesDownloaded; /* Number of files downloaded            */
  unsigned long  BytesUploaded;   /* Number of bytes uploaded              */
  unsigned long  BytesDownloaded; /* Number of bytes downloaded            */
  unsigned short Reserved_S7;     /* Reserved for future use               */
  unsigned short Reserved_S8;     /* Reserved for future use               */
  unsigned short Reserved_S9;     /* Reserved for future use               */
  unsigned short Reserved_S10;    /* Reserved for future use               */


  /* User settings ========================================================*/
  unsigned char  Terminal;        /* TTY, ANSI, VT100, AVATAR, RIPTERM...  */
  unsigned char  PageLength;      /* Lines per page                        */
  unsigned char  Language;        /* Language number                       */
  unsigned char  CharSet;         /* Charset number                        */
  unsigned char  Protocol;        /* Protocol number                       */
  unsigned char  Packer;          /* Packer number                         */
  unsigned char  DefReplySt;      /* Default reply style                   */
  unsigned char  EditorKeyLayOut; /* Reserved for future use               */
  unsigned char  WordWrap;        /* User word wrap setting                */
  unsigned short MaxPackMsg;      /* Max messages to pack with QWK/OMEN    */
  unsigned short LastModemSpeed;  /* Last modem speed divided by 300.      */
  unsigned char  Reserved_B1;     /* Reserved for future use               */
  unsigned char  Reserved_B2;     /* Reserved for future use               */
  unsigned char  Reserved_B3;     /* Reserved for future use               */
  unsigned char  Reserved_B4;     /* Reserved for future use               */
  unsigned char  Reserved_B5;     /* Reserved for future use               */

  /* String pointers ======================================================*/
  unsigned long  DoingActive;     /* Pointer User doing when active..      */
  unsigned long  LoginCommand;    /* Commands to be executed when logged in*/
  unsigned long  CommandAlias;    /* Pointers to aliases to commands       */
  unsigned long  SysNote;         /* Pointer to SysOps yellow sticker      */
  unsigned long  Reserved_L1;     /* Reserved for future use               */
  unsigned long  Reserved_L2;     /* Reserved for future use               */
  unsigned long  Reserved_L3;     /* Reserved for future use               */
  unsigned long  Reserved_L4;     /* Reserved for future use               */

  /* User groups ==========================================================*/
  unsigned long  UserGroups;      /* Max 32 user groups                    */
  unsigned long  ExtraGroups;     /* Reserved for future use               */

  /* Dates ================================================================*/
  SDATE          Birth;           /* User Birth date       (Changes!)      */
  LDATE          LastCall;        /* Last called           (Changes!)      */
  SDATE          LastCheck;       /* Checkked new files    (Changes!)      */
  SDATE          ExpireDate;      /* UNUSED: Rights expire (Changes!)      */

  /* Palette data =========================================================*/
  PALETTE        Palette;         /* User setted colors                    */

  unsigned long  ScriptLData1;    /* 32 Script setable bits.               */
  unsigned long  ScriptLData2;    /* 32 Script setable bits.               */
  unsigned long  ScriptLData3;    /* 32 Script setable bits.               */
  unsigned long  ScriptLData4;    /* 32 Script setable bits.               */
  unsigned long  ScriptLData5;    /* 32 Script setable bits.               */
  unsigned long  ScriptLData6;    /* 32 Script setable bits.               */
  unsigned long  ScriptLData7;    /* 32 Script setable bits.               */
  unsigned long  ScriptLData8;    /* 32 Script setable bits.               */
  unsigned long  ScriptLData9;    /* 32 Script setable bits.               */
  unsigned long  ScriptLData10;   /* 32 Script setable bits.               */

  /* Flags ================================================================*/
  unsigned long  AFlags;          /* Access flags; up, down, doors etc.    */
  #define AFLAG_UPLOAD            0x00000001
  #define AFLAG_DOWNLOAD          0x00000002
  #define AFLAG_DOORS             0x00000004

  unsigned long  SFlags;          /* Status flags; NewUser, Favoured etc.  */
  #define SFLAG_NEWUSER           0x00000001
  #define SFLAG_KILLED            0x00000002
  #define SFLAG_NOLOGIN           0x00000004
  #define SFLAG_GUEST             0x00000008
  #define SFLAG_FAVOURED          0x00000010
  #define SFLAG_NOCHAT            0x00000020
  #define SFLAG_ALWAYSYELL        0x00000040

  unsigned long  GFlags;          /* General option flags.                 */
  #define GFLAG_AUTOHELP          0x00000001
  #define GFLAG_TIPS              0x00000002
  #define GFLAG_CONFCHECK         0x00000004
  #define GFLAG_LOGINSTATUS       0x00000008
  #define GFLAG_AUTOREADMENU      0x00000010
  #define GFLAG_SHOWAINFO         0x00000020
  #define GFLAG_NODE_ENTMSG       0x00000040
  #define GFLAG_NODE_LOGIN        0x00000080
  #define GFLAG_LASTCALLERS       0x00000100
  #define GFLAG_SCROLLING_CHAT    0x00000200
  #define GFLAG_SWAP_BS_DEL       0x00000400

  unsigned long  BFlags;          /* General option flags.                 */
  #define BFLAG_COLOR_CMDS        0x00000001
  #define BFLAG_COLOR_PROMPTS     0x00000002
  #define BFLAG_COLOR_MENUS       0x00000004
  #define BFLAG_COLOR_MSGS        0x00000008
  #define BFLAG_COLOR_FILES       0x00000010
  #define BFLAG_BEEP_NODE_MSGS    0x00000020
  #define BFLAG_BEEP_OWN_MSGS     0x00000040
  #define BFLAG_BEEP_ERRORS       0x00000080

  unsigned long  RFlags;          /* Run script flags.                     */

  unsigned long  CFlags;          /* Control flags.                        */
  #define CFLAG_REREGISTER        0x00000001
  #define CFLAG_PASSWARN          0x00000002
  #define CFLAG_HANGUPPED         0x00000004

  unsigned long  MFlags;          /* Message option flags.                 */
  #define MFLAG_INSERT            0x00000001
  #define MFLAG_INDENT            0x00000002
  #define MFLAG_XYPOS             0x00000004
  #define MFLAG_TABMOVESTXT       0x00000008
  #define MFLAG_READREF           0x00000010
  #define MFLAG_UCASE_NAMES       0x00000020
  #define MFLAG_UCASE_OWN_NAME    0x00000040
  #define MFLAG_CLS_BEFORE        0x00000080
  #define MFLAG_MSG_HEADER_SKIP1  0x00000100
  #define MFLAG_MSG_HEADER_SKIP2  0x00000200
  #define MFLAG_NUMBER_OF_MSGS    0x00000400
  #define MFLAG_JOIN_STATUS       0x00000800
  #define MFLAG_REREAD_OWN        0x00001000
  #define MFLAG_JOIN_MODE_1       0x00002000
  #define MFLAG_JOIN_MODE_2       0x00004000
  #define MFLAG_JOIN_MODE_3       0x00008000

  unsigned long  FFlags;          /* File option flags.                    */
  #define FFLAG_GR_FILEPROT       0x00000001
  #define FFLAG_MORE_AFTER_LIST   0x00000002
  #define FFLAG_ELINE_AFTER_FILE  0x00000004
  #define FFLAG_DOWNLOAD_DESCS    0x00000008
  #define FFLAG_USE_CD_FILESYSTEM 0x00000010

  unsigned long  OFlags;          /* Offline option flags.                 */
  #define OFLAG_NEW_FILELIST      0x00000001

  unsigned long  EFlags1;         /* Extra flags.                          */
  unsigned long  EFlags2;         /* Extra flags.                          */
  unsigned long  EFlags3;         /* Extra flags.                          */
  unsigned long  EFlags4;         /* Extra flags.                          */

  unsigned long  SysOp;           /* SysOp flags.                          */
  #define SYSOP_SHOWUSER_1        0x00000001
  #define SYSOP_SHOWUSER_2        0x00000002
  #define SYSOP_SHOWUSER_3        0x00000004
  #define SYSOP_UNUSED_1          0x00000008
  #define SYSOP_CONFERENCES       0x00000010
  #define SYSOP_PRIVATEMAIL       0x00000020
  #define SYSOP_UNUSED_2          0x00000040
  #define SYSOP_UNUSED_3          0x00000080
  #define SYSOP_MODIFYFILES       0x00000100
  #define SYSOP_DELETEFILES       0x00000200
  #define SYSOP_UNUSED_4          0x00000400
  #define SYSOP_UNUSED_5          0x00000800
  #define SYSOP_EXITTODOS         0x00001000
  #define SYSOP_UNUSED_6          0x00002000
  #define SYSOP_UNUSED_7          0x00004000
  #define SYSOP_UNUSED_8          0x00008000
  #define SYSOP_EDITUSERS         0x00010000
  #define SYSOP_KILLUSER          0x00020000
  #define SYSOP_UNUSED_9          0x00040000
  #define SYSOP_UNUSED_10         0x00080000
  #define SYSOP_USERGROUPS        0x00100000
  #define SYSOP_UNUSED_11         0x00200000
  #define SYSOP_UNUSED_12         0x00400000
  #define SYSOP_UNUSED_13         0x00800000
} USER;


  #define FLAG_UPLOAD             (User.AFlags & AFLAG_UPLOAD)
  #define FLAG_DOWNLOAD           (User.AFlags & AFLAG_DOWNLOAD)
  #define FLAG_DOORS              (User.AFlags & AFLAG_DOORS)

  #define FLAG_NEWUSER            (User.SFlags & SFLAG_NEWUSER)
  #define FLAG_KILLED             (User.SFlags & SFLAG_KILLED)
  #define FLAG_NOLOGIN            (User.SFlags & SFLAG_NOLOGIN)
  #define FLAG_GUEST              (User.SFlags & SFLAG_GUEST)
  #define FLAG_FAVOURED           (User.SFlags & SFLAG_FAVOURED)
  #define FLAG_NOCHAT             (User.SFlags & SFLAG_NOCHAT)
  #define FLAG_ALWAYSYELL         (User.SFlags & SFLAG_ALWAYSYELL)

  #define FLAG_AUTOHELP           (User.GFlags & GFLAG_AUTOHELP)
  #define FLAG_TIPS               (User.GFlags & GFLAG_TIPS)
  #define FLAG_CONFCHECK          (User.GFlags & GFLAG_CONFCHECK)
  #define FLAG_LOGINSTATUS        (User.GFlags & GFLAG_LOGINSTATUS)
  #define FLAG_AUTOREADMENU       (User.GFlags & GFLAG_AUTOREADMENU)
  #define FLAG_SHOWAINFO          (User.GFlags & GFLAG_SHOWAINFO)
  #define FLAG_NODE_ENTMSG        (User.GFlags & GFLAG_NODE_ENTMSG)
  #define FLAG_NODE_LOGIN         (User.GFlags & GFLAG_NODE_LOGIN)
  #define FLAG_LASTCALLERS        (User.GFlags & GFLAG_LASTCALLERS)
  #define FLAG_SCROLLING_CHAT     (User.GFlags & GFLAG_SCROLLING_CHAT)
  #define FLAG_SWAP_BS_DEL        (User.GFlags & GFLAG_SWAP_BS_DEL)

  #define FLAG_COLOR_CMDS         (User.BFlags & BFLAG_COLOR_CMDS)
  #define FLAG_COLOR_PROMPTS      (User.BFlags & BFLAG_COLOR_PROMPTS)
  #define FLAG_COLOR_MENUS        (User.BFlags & BFLAG_COLOR_MENUS)
  #define FLAG_COLOR_MSGS         (User.BFlags & BFLAG_COLOR_MSGS)
  #define FLAG_COLOR_FILES        (User.BFlags & BFLAG_COLOR_FILES)
  #define FLAG_BEEP_NODE_MSGS     (User.BFlags & BFLAG_BEEP_NODE_MSGS)
  #define FLAG_BEEP_OWN_MSGS      (User.BFlags & BFLAG_BEEP_OWN_MSGS)
  #define FLAG_BEEP_ERRORS        (User.BFlags & BFLAG_BEEP_ERRORS)

  #define FLAG_REREGISTER         (User.CFlags & CFLAG_REREGISTER)
  #define FLAG_PASSWARN           (User.CFlags & CFLAG_PASSWARN)
  #define FLAG_HANGUPPED          (User.CFlags & CFLAG_HANGUPPED)

  #define FLAG_INSERT             (User.MFlags & MFLAG_INSERT)
  #define FLAG_INDENT             (User.MFlags & MFLAG_INDENT)
  #define FLAG_XYPOS              (User.MFlags & MFLAG_XYPOS)
  #define FLAG_TABMOVESTXT        (User.MFlags & MFLAG_TABMOVESTXT)
  #define FLAG_READREF            (User.MFlags & MFLAG_READREF)
  #define FLAG_UCASE_NAMES        (User.MFlags & MFLAG_UCASE_NAMES)
  #define FLAG_UCASE_OWN_NAME     (User.MFlags & MFLAG_UCASE_OWN_NAME)
  #define FLAG_CLS_BEFORE         (User.MFlags & MFLAG_CLS_BEFORE)
  #define FLAG_MSG_HEADER_SKIP1   (User.MFlags & MFLAG_MSG_HEADER_SKIP1)
  #define FLAG_MSG_HEADER_SKIP2   (User.MFlags & MFLAG_MSG_HEADER_SKIP2)
  #define FLAG_NUMBER_OF_MSGS     (User.MFlags & MFLAG_NUMBER_OF_MSGS)
  #define FLAG_JOIN_STATUS        (User.MFlags & MFLAG_JOIN_STATUS)
  #define FLAG_REREAD_OWN         (User.MFlags & MFLAG_REREAD_OWN)
  #define FLAG_JM1                (User.MFlags & MFLAG_JOIN_MODE_1)
  #define FLAG_JM2                (User.MFlags & MFLAG_JOIN_MODE_2)
  #define FLAG_JM3                (User.MFlags & MFLAG_JOIN_MODE_3)


  #define FLAG_GR_FILEPROT        (User.FFlags & FFLAG_GR_FILEPROT)
  #define FLAG_MORE_AFTER_LIST    (User.FFlags & FFLAG_MORE_AFTER_LIST)
  #define FLAG_ELINE_AFTER_FILE   (User.FFlags & FFLAG_ELINE_AFTER_FILE)
  #define FLAG_DOWNLOAD_DESCS     (User.FFlags & FFLAG_DOWNLOAD_DESCS)
  #define FLAG_USE_CD_FILESYSTEM  (User.FFlags & FFLAG_USE_CD_FILESYSTEM)

  #define FLAG_NEW_FILELIST       (User.OFlags & OFLAG_NEW_FILELIST)




/* Message header OffsetAttr flags ... */
#define MASK_KILLED     0x80000000L
#define MASK_PRIVATE    0x40000000L
#define MASK_READ       0x20000000L
#define MASK_SENT       0x10000000L
#define MASK_PACKED     0x08000000L /* Message is packed */

#define MASK_ALL        0xf8000000L /* All atributes ... */
#define MASK_OFFSET     0x07ffffffL /* Offset part ... */

/*
 * New MsgHeader for compressed messagebase.
 *
 *
 *
 */

typedef struct {
  unsigned long  OffsetAttr;    /* SubMsgHeader record address & Masks */
  unsigned short MsgToN;        /* Message to user number */
  unsigned short MsgFromN;      /* Message from user number */
  unsigned short ReplyTo;       /* Message that this is reply to. */
} NEW_MSGHEAD;


typedef struct {
  unsigned short MsgFromN;      /* Message from user number */
  unsigned short MsgToN;        /* Message to user number */
  unsigned short ReplyTo;
  unsigned long  OffsetAttr;    /* SubMsgHeader record address & Masks */
} MSGHEAD;


/*
 * New SubMsgHeader for compressed messagebase.
 * This will not be changed after message has saved to base. All changes
 * will be made to actual header.
 *
 *
 *
 *
 */

typedef struct {
  unsigned char  MsgFromName[NAMELEN];
  unsigned char  MsgToName[NAMELEN];
  unsigned char  Subject[40];

  time_t         MsgDate;       /* Message date using standard unix conversion */
  NETADDR        From;

  unsigned short MsgFlags;
  #define MSGFLAGS_MOVEDFROM_MASK    0x0fff
  #define MSGFLAGS_MOVED             0x1000
  #define MSGFLAGS_OFFLINE           0x2000
} NEW_SUBMSGHEAD;




typedef struct {
  unsigned char  MsgFrom[NAMELEN];
  unsigned char  MsgTo[NAMELEN];
  unsigned char  Subject[40];

  time_t         MsgDate;       /* Message date using standard unix conversion */
  unsigned char  MustBeZero_RepliesMade; /* Obsolite ... */
  unsigned short MustBeZero_FirstReply;  /* Obsolite ... */

  NETADDR        From;

  unsigned short MsgFlags;

  #define MSGFLAGS_MOVEDFROM_MASK    0x0fff
  #define MSGFLAGS_MOVED             0x1000
  #define MSGFLAGS_OFFLINE           0x2000
} SUBMSGHEAD;


typedef struct {
  SUBMSGHEAD     SubMsgHead;    /* Contains all message header information */
  unsigned char  MsgTxt[MSGTXTSIZE]; /* ... message text */
  unsigned char  GuardBytes[64];/* Extra safety bytes. Always zero */

  unsigned short LastLine;      /* Internal variable: Last message line */
  unsigned short BytesInMsg;    /* Internal variable: Bytes in message */

  unsigned short MsgInMem;      /* Internal variable: MessageNum in memory */
  unsigned short Conference;    /* Internal variable: Conference number */
} MESSAGE;


typedef struct {
  unsigned short VBoardMsgNumber;
  unsigned long  MsgID;
  unsigned short ZoneFrom;
  unsigned short NetFrom;
  unsigned short NodeFrom;
  unsigned short PointFrom;
  unsigned long  MessageCRC;
} ECHODUPE;



typedef struct {
  unsigned short UserNumber;    /* Message from usernumber n */
  unsigned short MessageArea;   /* Area to write */
  unsigned short ReplyTo;       /* Reply to, FALSE if write */
  unsigned long  MessageCRC;    /* CRC of message ??? */
} OFFLINEDUPE;


#define CA_READ         0x01
#define CA_WRITE        0x02
#define CA_SIGOP        0x04
#define CA_MEMBER       0x08
#define CA_INVITED      0x10
#define CA_OBLIGATORY   0x20

#define CA_GRP_READ     0x40
#define CA_GRP_WRITE    0x80

typedef struct {
  unsigned char  Access;
  unsigned short LastRead;  /* Max messages in area is 2^19-1=M messua */
} CONFACCESS;


typedef struct {
  unsigned char  Name[41];
  unsigned char  Description[40];
  unsigned char  EnterMsgText[24];   /* Wholla nkyy: Entering bullshit, Commenting*/
  unsigned char  SigOpName[NAMELEN];

  unsigned char  NetName[20];        /* International Fido etc..*/
  unsigned char  AreaTag[30];        /* Area TAG */
  unsigned char  MsgDir[60];         /* MSG conversion directory */
  unsigned char  OriginLine[73];     /* ' * Origin: The Pit...' */

  unsigned long  StartMsg;           /* Messages start at number */

  unsigned char  Group;              /* Conf belongs to group 0-Z */
  unsigned char  Scan;               /* How many messages newusers will get */
  unsigned char  NewUserAccess;      /* Newuser access level */
  unsigned char  GroupAccess[32];    /* Usergroups access levels */

  unsigned short ReplyConf;          /* Reserved, currently unused */
  unsigned char  MinRead;            /* Reserved, currently unused */
  unsigned char  MinAge;             /* Reserved, currently unused */

  unsigned char  Flags1;
  #define CONFFLAG1_POSTCONF             0x01
  #define CONFFLAG1_RESUMECONF           0x02
  #define CONFFLAG1_MUST                 0x04
  #define CONFFLAG1_SECRET               0x08
  #define CONFFLAG1_ALIASCONF            0x10
  #define CONFFLAG1_NOREPLY              0x20
  #define CONFFLAG1_NOMARK               0x40
  #define CONFFLAG1_ALLOW_PRIVATE        0x80

  unsigned char  Flags2;
  #define CONFFLAG2_NEWUSER_CAN_WRITE    0x01
  #define CONFFLAG2_OFFLINE_ONLY         0x02
  #define CONFFLAG2_NETAREA              0x04
  #define CONFFLAG2_CONVERT8BIT          0x08
  #define CONFFLAG2_STRICT_FIDO          0x10

/*unsigned char  Dummeli; */
  unsigned char  CharSet;            /* Net charset conversions: IBM, SF7, ISO */

  NETADDRPOINT   Hub;
  unsigned char  UnUsed1;
  NETADDRPOINT   Own;
  unsigned char  UnUsed2;
  NETADDRPOINT   Moderator;

} CONF;


typedef struct {
  unsigned char  Name[30];        /* FileArea name            30  */
  unsigned char  Description[50]; /* FileArea description     80  */
  unsigned char  Directory[41];   /* Directory to put files  121  */
  unsigned char  AreaTags[86];    /* FileEcho area tags      212  */

  unsigned short AreaOwner;
  unsigned char  AreaFlags;
  unsigned short CreditModify;
  unsigned short PrivateTo;       /*                         214  */
  unsigned char  SortMethod;      /*                         215  */

  NETADDR        SendTo;

  unsigned char  AreaOptions;
  #define FILEAREA_OPTS_SENDNEWUPLOADS  0x01
  #define FILEAREA_OPTS_CDROMAREA       0x02
  #define FILEAREA_OPTS_UPLOADAREA      0x04

  unsigned short AreaIDByte;      /* Areas are sorted by filesort */
  unsigned short LastAreaIDByte;  /* Last subdirectory ID byte */
  unsigned short ParentAreaIDByte;/* Parent area ID byte, 0 if root area */

  unsigned long  SId;             /* Index START number */
  unsigned long  EId;             /* Index END number */
  unsigned short FilesInArea;     /* Statistics, updated by filesort only */
  unsigned short Reserved;
} FILEAREA; /* Version 2.00 and above, total 240 bytes  */

typedef struct {
  unsigned char  CPath[128];
  FILEAREA       AreaData;
} FILEAREAREC;



/* New FileArea record for v1.06 => ... */
typedef struct {
  unsigned char  Name[41];      /* FileArea name */
  unsigned char  Directory[41]; /* Directory to put files */

  unsigned short PrivateTo;
  unsigned char  SortMethod;

  unsigned char  AreaTags[120]; /* FileEcho area tags */
  unsigned short FHubZone;
  unsigned short FHubNet;
  unsigned short FHubNode;

  unsigned SendNewUploads : 1;  /* Hatch new uploads to echo */
  unsigned CDROMArea      : 1;  /* Exclude area from newfile scan.. */
  unsigned UnUsed         : 6;  /* Again some unused bits */

  unsigned short AreaIDByte;    /* Areas are sorted by filesort */
  unsigned long  SId;           /* Index START number */
  unsigned long  EId;           /* Index END number */
  unsigned short FilesInArea;   /* Statistics, updated by filesort only */
} OLD_FILEAREA; /* Versios prior 2.00 */





typedef struct {
  unsigned char  Name[52];     /* File name, max 32 chars */
  unsigned long  DescPointer;  /* Pointer to desc file */
  unsigned char  DescLines;    /* Lines in description */
  unsigned long  Size;         /* Size of the file */
  unsigned short TrueDate;     /* UNUSED: File truly created */
  unsigned short UploadDate;   /* Date uploaded */
  unsigned short AreaIDByte;   /* In filearea number */
  unsigned short FileTo;       /* Receiver.. */
  unsigned short FileFrom;     /* Uploader */
  unsigned short DlTimes;      /* Downloaded n times */
  unsigned short Credits;      /* Credits required */
  unsigned short CredsGiven;   /* Credits given to uploader */
  unsigned char  Attributes;
} NEW_FILEREC;


/***************************************************************************
 * VBoard files.dat file format. Versions 1.19 =>
 *
 * Improvements to make in next files.dat change.
 * ===================================================================
 * + Change SDATE structures to DAYNUMBERS.. saves 1 byte and are
 *   much faster to operate with.
 * + Add ancient bit.
 *
 *
 */

typedef struct {
  unsigned char  Name[52];     /* File name, max 32 chars */
  unsigned long  DescPointer;  /* Pointer to desc file */
  unsigned char  DescLines;    /* Lines in description */
  unsigned long  Size;         /* Size of the file */
  SDATE          TrueDate;     /* UNUSED: File truly created */
  SDATE          UploadDate;   /* Date uploaded */
  unsigned short AreaIDByte;   /* In filearea number */
  unsigned short FileTo;       /* Receiver.. */
  unsigned short FileFrom;     /* Uploader */
  unsigned short DlTimes;      /* Downloaded n times */
  unsigned short Credits;      /* Credits required */
  unsigned short CredsGiven;   /* Credits given to uploader */

  unsigned char  Flags;
  #define FILEFLAG_FREE         0x01
  #define FILEFLAG_ANCIENT      0x02
  #define FILEFLAG_RATHEROLD    0x04
  #define FILEFLAG_BADCRC       0x08
  #define FILEFLAG_SCANNED      0x10
  #define FILEFLAG_VIRUS        0x20
  #define FILEFLAG_DELETED      0x40

} FILEREC;



typedef struct {                    /* sizeof(DOOR) == 512 bytes */
  unsigned char  Name[30];
  unsigned char  Command[40];
  unsigned char  WhoText[24];       /* TARKISTA CONFFIN ASETUKSISTA!!! */

  unsigned char  PassWord[16];      /* Door requires a password */

  unsigned char  WorkingDir[64];
  unsigned char  ExecString[128];

  unsigned char  Reserved[198];

  unsigned char  DoorCmdMenus;

  unsigned long  ReservedF;     /* Reserved for future developement (AND MASK) */
  unsigned long  UserGroup;     /* Requires membership in any of these usergroups (OR MASK)*/

  unsigned char  DoorAcc;
  #define DOORACC_NOT_NEWUSER    0x01
  #define DOORACC_DOORS          0x02
  #define DOORACC_UPLOAD         0x04
  #define DOORACC_DOWNLOAD       0x08
  #define DOORACC_FAVOURED       0x10
  #define DOORACC_ANY_SYSOPBIT   0x20
  #define DOORACC_SYS_EXITDOS    0x40
  #define DOORACC_ALL_SYSOPBITS  0x80

  unsigned char  DoorSets;
  #define DOORSET_TIMERUNS        0x01
  #define DOORSET_COMMANDONLY     0x02
  #define DOORSET_EXECUTE_AS_VDM  0x80

  unsigned char  DoorDrops;
  #define DOORDROP_DOORINFODEF   0x01
  #define DOORDROP_DOORSYS       0x02

} DOOR;


#define NATTR_HIDED     0x01
#define NATTR_NOTAVAIL  0x02

typedef struct {
  time_t         LoginTime;   /* Time when user logged into system.        */
  time_t         LastUpdated; /* Last time who was updated.                */
  unsigned short UserNumber;  /* Number of user, 1=SysOp.                  */
  unsigned char  FilterNMsgs; /* Node message filter.                      */
  unsigned char  Name[NAMELEN];/* User name.                               */
  unsigned char  City[30];    /* User's city information.                  */
  unsigned char  Status;      /* What user is doing.                       */
  unsigned char  Doing[25];   /* Doing string if active.                   */
  unsigned long  ModemSpeed;  /* User's modem speed, 0 if local.           */
  unsigned char  EC;          /* Error correction type.                    */
  unsigned char  Attributes;  /* Hided, available, None yet.               */
  unsigned char  Reserved[39];/* Reserved for futuere use.                 */
} NODE;


/*
 * Node message types used in NodeMsg.MsgType.
 *
 * - In login, logoff, Join and exit chat messages User's name must be
 *   in txt field.
 * - Entered message is most complex, four first bytes tell length of
 *   strings in following order; message number, area name, message to
 *   name. Unterminated strings follow after these bytes.
 * - In eject message txt if name of user who has used eject/kick command.
 */

#define NODE_MESSAGE   0x01   /* Normal nodemessage.                       */
#define NODE_LOGIN     0x02   /* Someone just logged into system.          */
#define NODE_LOGOFF    0x04   /* .. and out                                */
#define NODE_ENTERED   0x08   /* Someone entered a message.                */
#define NODE_EJECT     0x10   /* Eject node.                               */
#define NODE_JOINGCHAT 0x20   /* Someone just joined to group chat.        */
#define NODE_EXITGCHAT 0x21   /* Someone quited group chat.                */

typedef struct {
  unsigned short NodeFrom;    /* Node number where message originated.     */
  unsigned char  MsgType;     /* Type of nodemessage.                      */
  unsigned char  SenderName[NAMELEN]; /* Who sent it.                      */
  unsigned char  Txt[84];     /* Text or data part of message.             */
  unsigned char  Reserved[11];/* Reserved for future use.                  */
} NODEMSG;


#define BBSDEF_H_DEF
#endif  /* BBSDEF_H_DEF */
