cc = cc

# Required options
cflags = -fpack-struct -DUNIX -DSKYLINER
# All warnings on
cflags += -Wall

# Optimizations
cflags += -O3 -m486 -fomit-frame-pointer -pipe

# Debugging
#cflags += -g

# malloc() debugging. Slows up but log shows if allocated memory wasn't ever
# deallocated (internal smodem still has these..).
cflags += -DDEBUG_MALLOC

# open() and close() debugging.
cflags += -DDEBUG_FILES

# Define these if you don't have strchr() or strstr() functions
#-DWANT_STRCHR -DWANT_STRSTR

# Use buildin SModem
BUILDIN_SMODEM = 1

ifdef BUILDIN_SMODEM
cflags += -DBUILDIN_SMODEM
endif

# Linker
ld = cc
lflags =

outdir=
objext=o
include objs.inc

objs += mdm_lnx.o keyb_lnx.o unix.o

ifdef BUILDIN_SMODEM
objs += $(smodem)
endif

.SUFFIXES: .c .o

.c.o:
	$(cc) $(cflags) -c $< -o $*.o

all: ../bbs

../bbs: $(objs)
	$(ld) $(lflags) $(objs) -o ../bbs
	rm -f /usr/local/bin/bbs
	cp ../bbs /usr/local/bin
#	install ../bbs /usr/local/bin -g bbs -o bbs -m 0770

output.o: version.h
language.o: language.h
