/* YAK - Copyright (c) 1997 Timo Sirainen - read license.txt */

/* menutype.c - Run menutypes */

/* Todo: Rewrite this whole file. :) */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "os.h"
#include "threads.h"
#include "ask_str.h"
#include "files.h"
#include "showfile.h"
#include "toplist.h"
#include "nodes.h"
#include "bbs_func.h"
#include "output.h"
#include "fsearch.h"
#include "fareas.h"
#include "mareas.h"
#include "filelist.h"
#include "download.h"
#include "messages.h"
#include "lastcall.h"
#include "grabmsgs.h"
#include "menutype.h"
#include "keyb.h"
#include "userbase.h"
#include "chat.h"
#include "logfile.h"
#include "modem.h"
#include "setup.h"
#include "timeslic.h"
#include "config.h"
#include "language.h"
#include "gwar.h"
#include "tetris.h"
#include "grpchat.h"

char answer[256];

void create_dorinfo(void)
{
    FILE *F;
    char tmp[50],buf[20],name[36],*last = NULL,*strp;

    strcpy(name,sysop_name);
    strp = strchr(name,' ');
    if (strp != NULL)
    {
        *strp++ = '\0';
        last = strp;
    }
    strp = strrchr(name,' ');
    if (strp != NULL) last = strp+1;

    sprintf(buf, "%sdorinfo%d.def", common_path, nodenum);
    F = fopen(buf,"w+b");
    if (F == NULL) return;
    chmod(buf, 0660);

    fprintf(F,"%s\r\n",strupr(strcpy(tmp,bbs_name)));
    fprintf(F,"%s\r\n",strupr(name));
    fprintf(F,"%s\r\n",strupr(last));
#ifdef __DOS__
    fprintf(F,"COM%d\r\n", hCom);
#else
    fprintf(F,"COM%d\r\n", hCom == -1 ? 0 : comport);
#endif
    fprintf(F,"%lu BAUD,N,8,1\r\n", bpsrate);
    if (user.Emulation == USER_EMULATION_ASCII)
        fprintf(F,"0\r\n");
    else
        fprintf(F,"1\r\n");

    strcpy(name,usrsub.name);
    strp = strchr(name,' ');
    if (strp != NULL)
    {
        *strp++ = '\0';
        last = strp;
    }
    strp = strrchr(name,' ');
    if (strp != NULL) last = strp+1;

    fprintf(F,"%s\r\n", name);
    fprintf(F,"%s\r\n", last);
    fprintf(F,"%s\r\n", usrsub.city);
    fprintf(F,"1\r\n");
    fprintf(F,"%lu\r\n", user.SecLevel);
    fprintf(F,"%d\r\n", time_left);

    fclose(F);
}

void take_data_param(char *field, char *parms)
{
    char *strp = parms;
    int hipsu = 0;

    while (*strp == ' ') strp++;
    if (*strp == ';')
    {
        *field = '\0';
        return;
    }
    if (*strp == ',')
    {
        /* , = cr */
        *field++ = '\n';
        strp++;
    }
    else
    {
        while (*strp != '\0' && (hipsu || (*strp != ';' && *strp != ' ' && *strp != ',')))
        {
            if (*strp == '\"')
            {
                if (hipsu)
                {
                    *field++ = *strp++;
                    break;
                }
                hipsu = 1;
            }
            *field++ = *strp++;
        }
    }
    *field = '\0';
    while (*strp == ' ') strp++;

    memmove(parms, strp, strlen(strp)+1);
}

void take_param(char *field)
{
    take_data_param(field, parms);
}

int run_menutype(unsigned menutype, char *data)
{
    unsigned long lnum;
    char *strp, tmp[256];
    struct stat statrec;
    int slen;

    /* data must be between " characters */
    if (data[0] != '"')
    {
        data[0] = '\0';
    }
    else
    {
        slen = strlen(data)-1;
        if (data[slen] != '"') slen = 0;
        data[slen] = '\0';
        if (slen != 0) data++;
    }

    switch (menutype)
    {
        case MENU_SHOW_TEXT:
            output("%s", data);
            break;
        case MENU_ASK_STRING:
            answer[0] = 0;
            strp = strchr(data, ' ');
            if (strp != NULL) *strp++ = '\0';
            if (!ask_string(strp == NULL ? "" : strp, answer, (int) atol(data), 0, NULL)) return 1;
            break;
        case MENU_GOTO_MENU:
            strcpy(menuname,data);
            return 2;
        case MENU_RELOGIN:
            {
                int f;

                /* Create relogin semaphore */
                sprintf(tmp, "%srelogin.%d", common_path, nodenum);
                f = FileCreate(tmp, CREATE_MODE);
                if (f == -1) break;
                FileClose(f);

                /* Hang up.. */
                return 1;
            }
        case MENU_LOGOFF:
            if (data[0] == '\0') take_param(data);
            if (yes_no(lang[LANG_LOGOFF], 0, &data))
            {
                /* Hang up */
                return 1;
            }
            break;
        case MENU_SHOW_ANSI:
            show_file(data);
            break;
        case MENU_YELL:
            if (data[0] == '\0')
            {
                strcpy(data, parms);
                parms[0] = '\0';
            }
            yell_sysop(data);
            break;
        case MENU_USERLIST:
            if (data[0] == '\0') take_param(data);
            userlist(data);
            break;
        case MENU_LASTCALLERS:
            last_callers();
            break;
        case MENU_BBSUSAGE:
            if (data[0] == '\0') take_param(data);
            bbs_time_usage(data);
            break;
        case MENU_LASTNODEMSGS:
            display_old_nodemsgs();
            break;
        case MENU_SHOW_JOBS:
            show_jobs();
            break;
        case MENU_KILL_JOB:
            if (data[0] == '\0') take_param(data);
            kill_job(data);
            break;
        case MENU_FAREA_CHANGE:
            if (data[0] == '\0') take_param(data);
            if (select_farea(data) == 0)
                output(lang[LANG_DIR_NOT_FOUND]);
            break;
        case MENU_FAREA_LIST:
            if (data[0] == '\0') take_param(data);
            list_files(data);
            break;
        case MENU_FAREA_FILESEARCH:
            if (data[0] == '\0') take_param(data);
            file_search(data);
            break;
        case MENU_FAREA_KEYSEARCH:
            if (data[0] == '\0') take_param(data);
            keyword_search(data);
            break;
        case MENU_FAREA_NEWFILES:
            if (data[0] == '\0') take_param(data);
            newfiles_search(data);
            break;
        case MENU_FAREA_DOWNLOAD:
            if (data[0] == '\0') take_param(data);
            download_files(data);
            break;
        case MENU_FAREA_DELETE:
            if (data[0] == '\0') take_param(data);
            delete_file(data);
            break;
        case MENU_FAREA_RENAME:
            if (data[0] == '\0') take_param(data);
            rename_file(data);
            break;
        case MENU_FAREA_UPLOAD:
            upload_files(1);
            break;
        case MENU_MAREA_CHANGE:
            /* Select new message area */
            if (data[0] == '\0') take_param(data);
            select_marea(data);
            break;
        case MENU_MSG_READ:
            draw_msg(current_msg);
            break;
        case MENU_MSG_NEXT:
            next_message(2);
            break;
        case MENU_MSG_PREV:
            prev_message(2);
            break;
        case MENU_LIST_MSGS:
            if (data[0] == '\0') take_param(data);
            list_msgs(data);
            break;
        case MENU_MSG_ENTER:
            /* Enter new message */
            if (data[0] == '\0') take_param(data);
            enter_message(0,0,data);
            break;
        case MENU_MSG_REPLY:
            enter_message(1,0,NULL);
            break;
        case MENU_MSG_REPLY_ANOTHER:
            enter_message(1,1,NULL);
            break;
        case MENU_MSG_GOTO:
            /* Jump to message # */
            if (data[0] == '\0') take_param(data);
            conv_macros(data,tmp);
            if (sscanf(tmp,"%lu",&lnum) == 1)
                goto_message(lnum);
            else
                output(lang[LANG_MSG_NOT_FOUND]);
            break;
        case MENU_MSG_DOWN:
            /* Download message packet */
            if (data[0] == '\0') take_param(data);
            grab_messages(data);
            break;
        case MENU_MSG_RESTORE:
            if (data[0] == '\0') take_param(data);
            if (stricmp(data,"CALL") == 0)
            {
                if (restore_pointers(ptrs_this_call) == 1)
                    output("\r\nLastread pointers restored to start of call\r\n");
            }
            if (stricmp(data,"CLEAR") == 0)
            {
                clear_pointers();
                output("\r\nLastread pointers cleared\r\n");
            }
            break;
        case MENU_MSG_KILL:
            kill_message();
            break;
        case MENU_MAREA_PTR_DAYS:
            /* Select new message area */
            if (data[0] == '\0') take_param(data);
            pointer_days(data);
            break;
        case MENU_MAREA_SHOWSTAT:
            show_mareas_status();
            break;
        case MENU_MAREA_NEXT_NEW:
            next_new_message(1);
            break;
        case MENU_SETUP_EDIT:
            if (data[0] == '\0') take_param(data);
            edit_setup(data);
            break;
        case MENU_IDIOT_MODE:
            if (stricmp(data, "Global War") == 0)
            {
                /* Run build-in Global War */
                global_war();
                break;
            }
            if (stricmp(data, "Tetris") == 0)
            {
                /* Run build-in Tetris */
                play_tetris();
                break;
            }
            create_dorinfo();
#ifdef UNIX
            idiot_mode(data);
#elif defined (__OS2__)
            noderec.doing = DOING_DOOR; noderec.data[0] = '\0';
            update_nodefile(0);

            conv_macros(data,tmp);
            flush_transmit();
            block_thread = 1;
            write_log("Running door '%s'", tmp);
            system(tmp);
            block_thread = 0;

            noderec.doing = DOING_NOTHING;
            update_nodefile(0);
#else
            system(data);
#endif
            sprintf(tmp, "%sdorinfo%d.def", common_path, nodenum);
            remove(tmp);
            break;
        case MENU_EXECUTE:
            output("\r\n");
            create_dorinfo();
            system(data);
            sprintf(tmp, "%sdorinfo%d.def", common_path, nodenum);
            remove(tmp);
            break;
        case MENU_EXECUTE_SHOW_OUTPUT:
            output("\r\n");
            create_dorinfo();
            output_modem();
            system(data);
            output_screen();
            sprintf(tmp, "%sdorinfo%d.def", common_path, nodenum);
            remove(tmp);
            break;
        case MENU_WHO:
            display_who();
            break;
        case MENU_NODEMSG:
            /* Send node message */
            if (data[0] == '\0')
            {
                strcpy(data, parms);
                parms[0] = '\0';
            }
            send_nodemsg(data);
            break;
        case MENU_MAREA_PTRS:
            update_pointers(current_msg-1);
            break;
        case MENU_SHELL:
            if (in_group("sysop"))
            {
#ifdef UNIX
                KbdDeInit();
                output_modem();
                system(shell);
                output_screen();
                KbdInit();
#endif
            }
            break;
        case MENU_SCORELIST:
            create_user_score_list();
            break;
        case MENU_CHANGE_USER:
            if (in_group("sysop"))
            {
                if (!write_user())
                {
                    write_log("Can't write to userbase.");
                    output("\r\nCan't write to userbase.\r\n");
                    break;
                }

                if (data[0] == '\0') take_param(data);

                /* Get user name */
                tmp[0] = '\0';
                if (!ask_string("\r\n@X07Read user: ", tmp, 35, 0, &data) || tmp[0] == '\0') break;

                /* Read user */
                strp = tmp;
                while (*strp >= '0' && *strp <= '9') strp++;
                if (*strp != '\0' || sscanf(tmp, "%lu", &lnum) != 1)
                    lnum = scan_user(tmp);
                else if (lnum > users()) lnum = 0;

                if (lnum != 0)
                {
                    if (read_user(lnum, 1))
                        output("\r\n@X07OK. You're now %s", usrsub.name);
                    else
                        output("\r\n@X07Failed.");
                }
                else
                {
                    output("\r\n@X07No such user as '%s'", tmp);
                }
            }
            break;
        case MENU_KILL_USER:
            if (in_group("sysop"))
            {
                user.Attrib1 ^= USER_ATTRIB_DELETED;
                if (user.Attrib1 & USER_ATTRIB_DELETED)
                    output(lang[LANG_USER_DELETED]);
                else
                    output(lang[LANG_USER_UNDELETED]);
            }
            break;
        case MENU_KICK_USER:
            if (in_group("sysop"))
            {
                if (data[0] == '\0') take_param(data);
                tmp[0] = '\0';
                if (!ask_string("\r\n@X07Kick user from line: ", tmp, 5, 0, &data) || tmp[0] == '\0') break;
                lnum = atol(tmp);
                send_nodetext("\x04", lnum);
            }
            break;
        case MENU_USER_TIME:
            if (in_group("sysop"))
            {
                tmp[0] = '\0';
                if (data[0] == '\0') take_param(data);
                if (!ask_string("\r\n@X07Give time to node: ", tmp, 5, 0, &data) || tmp[0] == '\0') break;
                lnum = atol(tmp);
                tmp[0] = NODETEXT_CHGTIME; tmp[1] = '\0';
                if (data[0] == '\0') take_param(data);
                if (!ask_string("\r\n@X07How many minutes to increase user's time (negative allowed): ", tmp+1, 5, 0, &data) || tmp[1] == '\0') break;
                send_nodetext(tmp, lnum);
            }
            break;
        case MENU_GROUP_CHAT:
            group_chat();
            break;
        case MENU_SPY:
            if (!in_group("sysop")) break;

            if (data[0] == '\0') take_param(data);
            tmp[0] = '\0';
            if (!ask_string("\r\n@X07Spy line: ", tmp, 5, 0, &data) || tmp[0] == '\0') break;
            lnum = atol(tmp);

            output("@CR@@X07OK. Press ctrl-c when you're finished.@CR@");

            tmp[0] = NODETEXT_SPY;
            sprintf(tmp+1, "%d %s", nodenum, devname);
            send_nodetext(tmp, lnum);

            sprintf(tmp, "%snodemsg.%d", common_path, nodenum);
            tmp1_str[0] = 0;
            while (tmp1_str[0] == 0)
            {
                if (!carr_det()) break;

                if (stat(tmp, &statrec) == 0 && statrec.st_size > 0)
                {
                    /* Found node file! */
                    display_nodefile(tmp, "@CR@");
                }

                give_timeslice();
            }
            tmp[0] = NODETEXT_DESPY; tmp[1] = '\0';
            send_nodetext(tmp, lnum);
            output("@CR@@X07Spying finished.@CR@");
            break;
        default:
            printf("\nUnknown menutype %u\n",menutype);
            break;
    }

    while (parms[0] == ';') memmove(parms, parms+1, strlen(parms));
    return 0;
}
