/* YAK - Copyright (c) 1997 Timo Sirainen - read license.txt */

#ifndef __NODES_H
#define __NODES_H

#include <time.h>

enum
{
    DOING_DOWN,
    DOING_NOTHING,
    DOING_IDLE,
    DOING_FILELIST,
    DOING_READ,
    DOING_WRITE,
    DOING_DOWNLOAD,
    DOING_DOWNLOAD_GROUP,
    DOING_UPLOAD,
    DOING_DOOR,
    DOING_LOGGING_IN,
    DOING_CHATTING,
    DOING_NEWFILES,
    DOING_FILE_SEARCH,
    DOING_GRABBING,
    DOING_WAITING_CALLER,
    DOING_GROUPCHAT,

    WHO_DOINGS
};

#define NODETEXT_NORMAL         1
#define NODETEXT_MSGWRITTEN     2
#define NODETEXT_NODEMSG        3
#define NODETEXT_KICKOUT        4
#define NODETEXT_CHGTIME        5
#define NODETEXT_SPY            6
#define NODETEXT_DESPY          7
#define NODETEXT_QUITSPY        8

extern char **node_doing;

typedef struct
{
    char name[36];
    char city[26];
    time_t login;
    unsigned long BPS;
    unsigned char doing;
    char data[256];
}
NODE_REC;

#define MAX_NODEMSGS_IN_MEMORY 100

typedef struct SAVED_NODEMSG
{
    struct SAVED_NODEMSG *next;
    char text[256];
}
SAVED_NODEMSG;

extern NODE_REC noderec;

void display_who(void);
void send_nodemsg(char *data);
void close_node_messages(void);
int display_nodefile(char *fname, char *startup);
void display_old_nodemsgs(void);

int open_nodefile(void);
void close_nodefile(void);
void update_nodefile(int no_change);
int read_nodefile(unsigned node, NODE_REC *noderec);
void send_nodetext(char *text, int node);

#endif
