/* Make ifcico to poll for a node */

/*
   Returns:
     0 = poll ok
     1 = command line error
     2 = couldn't call
     3 = session failure
*/

#define tty1 1
#define tty2 3

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int str2addr(char *addrstrp, unsigned short *zone, unsigned short *net, unsigned short *node, unsigned short *point)
{
    char *pstr;
    char addrstr[50],pos;

    strcpy(addrstr,addrstrp); pos = 0;
    for (pstr = addrstr; ; pstr++)
    {
        if (*pstr >= '0' && *pstr <= '9') continue;
        if (*pstr == ':' && pos == 0) { *pstr = ' '; pos = 1; continue; }
        if (*pstr == '/' && pos == 1) { *pstr = ' '; pos = 2; continue; }
        if (*pstr == '.' && pos == 2) { *pstr = ' '; pos = 3; continue; }
        if (*pstr == '@') { *pstr = '\0'; break; }
        if (*pstr == '\0') break;
        printf("Error : str2addr(\"%s\") position %d ('%c')\n",addrstrp,(int) (pstr-addrstr)+1,*pstr);
        return 0;
    }

    *zone = 0; *net = 0; *node = 0; *point = 0;
    return sscanf(addrstr,"%hu %hu %hu %hu",zone,net,node,point) >= 3;
}

int main(int argc, char *argv[])
{
    unsigned short zone, net, node, point;
    char str[100];
    int ret, device, tries;

    if (argc != 2 || !str2addr(argv[1], &zone, &net, &node, &point))
    {
        printf("Usage: poll <node address>\n");
        return 1;
    }

    device = tty1;
    for (tries = 0; tries < 5; tries++)
    {
        sprintf(str, "/usr/local/bin/ifcico -r1 -lttyS%d f%d.n%d.z%d", device, node, net, zone);
        ret = system(str);
        if ((ret & 0xff) != 0)
        {
            /* Error running ifcico */
            return 1;
        }

        ret >>= 8;

        if (ret == 0)
        {
            /* OK, toss mail. */
            system("/usr/local/bin/xtoss toss");
            system("/usr/local/bin/xfix toss");
            system("rm /usr/local/lib/yak/msgareas.idx");
            return 0;
        }

        if (ret == 1 || ret == 3)
        {
            /* Port unavailable or modem doesn't answer, try another */
            tries--;
            if (device == tty2)
                device = tty1;
            else
            {
                device = tty2;
                sleep(30); /* First sleep half a minute */
            }
            continue;
        }

        if (ret >= 10)
        {
            /* Session failure, don't try again. */
            return 3;
        }

        /* Try again after about 3 min sleep */
        sleep(60*3 + ((rand() % 60)-30));
    }

    return 2;
}
