#define _far
#define _fastcall

#include <string.h>
#include <limits.h>
#include <time.h>
#include "smodem.h"
#include "../output.h"
#include "../files.h"
#include "../grpchat.h"
#include "../memory.h"

void split_text(char *p, int size);
void terminal_entry(char *str);
void scroll_win(void);

extern unsigned Key; /* Key pressed */
extern time_t timer; /* Idle counter */
extern int quiet;    /* Quiet? */
extern unsigned char mslp_mode[6];

static int inputlen = 0;
static int ovry = 0;

static char *entry;

void init_interface(void)
{
    entry = (char *) _malloc(1024);

    quiet = 1;
    inputlen = 0; ovry = 0;
    loc_output("@X07@CLR@@GOTO:1,%d@@X17@CLREOL@", scrlength);
    /*loc_output("@X07@CLR@@X30D:@CLREOL@@RIGHT:36@U:@GOTO:1,%d@@X17@CLREOL@", scrlength);

    loc_output("@GOTO:1,2@@X07Smodem@RIGHT:42@MSLP @X0F%s @X07window", mslp_mode);
    loc_output("@GOTO:16,2@Download");
    loc_output("@GOTO:32,2@Upload");
    loc_output("@GOTO:2,3@File size");
    loc_output("@GOTO:2,4@Bytes left");
    loc_output("@GOTO:2,5@Total files");
    loc_output("@GOTO:2,6@Total bytes");
    loc_output("@GOTO:2,7@Files left");
    loc_output("@GOTO:2,8@Bytes left");
    loc_output("@GOTO:2,9@Average cps");
    loc_output("@GOTO:2,10@Current cps");

    loc_output("@GOTO:48,3@Transmit window");
    loc_output("@GOTO:48,4@Packet size");
    loc_output("@GOTO:48,5@Received packets");
    loc_output("@GOTO:48,6@Received bytes");
    loc_output("@GOTO:48,7@Receive errors");
    loc_output("@GOTO:48,8@Transmitted packets");
    loc_output("@GOTO:48,9@Transmitted bytes");
    loc_output("@GOTO:48,10@Transmitte errors");

    display_bar(100, 26);
    display_bar(100, 42);*/
}

void deinit_interface(void)
{
    loc_output("@CR@");
    _free(entry);
}

void ErrMsg(char *Err, char *Msg)
{
    char text[256];

    scroll_win();

    loc_output("@X0F");
    sprintf(text,"%s : %s",Err,Msg);
    split_text(text, strlen(text));
}

void term_msg(char *str) { str = str; }

/* Return 0 to quit. */
int keyboard_run(void)
{
    char *strp;

    for (;;)
    {
        strp = check_grpfile(1);
        if (strp != NULL)
        {
            /* Groupchat message found */
            conv_macros(strp, entry);
            terminal_entry(entry);
        }

        message_run();
        if (!smodem_run()) break;

        switch (Key)
        {
            case 1:
                /* Ctrl-A - Help */
                term_msg("");
                term_msg(" [ Ctrl-A ]  Show this help");
                term_msg(" [ Ctrl-U ]  Upload file wrote to prompt (write c:\file.name and press Ctrl-U)");
                term_msg(" [ Ctrl-D ]  Download file wrote to prompt");
                term_msg(" [ Ctrl-B ]  Toggle bell on/off");
                term_msg(" [ Ctrl-L ]  Clear window");
                break;

            case 2:
                /* Ctrl-B - Toggle bell on/off */
                quiet = !quiet;
                ErrMsg("Yell", quiet ? "On" : "Off");
                break;

            case 3:
                /* Ctrl-C - Quit */
                return 0;

            case 4:
                /* Ctrl-D - Download */
                input[inputlen] = 0;
                download(input,NULL,NULL);
                inputlen = 0; ovry = 0;
                loc_output("@X17@GOTO:1,%d@@CLREOL@", scrlength);
                if (promptlen > 0)
                    loc_output("@GOTO:1,%d@%s:", scrlength, terminal_prompt);
                break;

            case 8:
                if (!inputlen) break;
                loc_output("@X17");
                if (ovry != promptlen)
                {
                    ovry--;
                    loc_output("@GOTO:%d,%d@@INSCHR@\b%c", promptlen+1, scrlength, input[ovry]);
                }
                --inputlen;
                loc_output("@GOTO:%d,%d@ \b", inputlen-ovry+promptlen+1, scrlength);
                break;

            case 12:
                /* Ctrl-L - Clear window */
                loc_output("@X07@CLR@@GOTO:1,%d@@X17@CLREOL@", scrlength);
                break;

            case 13:
                input[inputlen] = 0;
                write_grpline(input);
                terminal_entry(input);
                inputlen = 0; ovry = 0;
                loc_output("@X17@GOTO:1,%d@@CLREOL@", scrlength);
                if (promptlen > 0)
                    loc_output("@GOTO:1,%d@%s:", scrlength, terminal_prompt);
                break;

            case 21:
                /* Ctrl-U - Upload */
                input[inputlen] = 0;
                upload(input,NULL,NULL,1);
                inputlen = 0; ovry = 0;
                loc_output("@X17@GOTO:1,%d@@CLREOL@", scrlength);
                if (promptlen > 0)
                    loc_output("@GOTO:1,%d@%s:", scrlength, terminal_prompt);
                break;

            default:
                if (Key < 32 || inputlen >= sizeof input - 1) break;
                loc_output("@X17");
                if (inputlen-ovry+promptlen == 79)
                {
                    loc_output("@GOTO:%d,%d@@DELCHR@@GOTO:79,%d@ \b", promptlen+1, scrlength, scrlength);
                    ovry++;
                }
                input[inputlen++] = Key;
                loc_output("@GOTO:%d,%d@%c", inputlen-ovry+promptlen, scrlength, Key);
                idle_start_time = timer;
        }
    }

    return 1;
}

int display_time(int cps, long total, long size, int pos)
{
    int i, j;
    long l;

    if (cps && size)
    {
        l = size / cps;
        i = (int)(l / 3600);
        l %= 3600;
        j = (int)(l / 60);
        if (!i)
        {
            i = j;
            j = (int)(l % 60);
        }
        loc_output("@GOTO:%d,1@%2d:%2.2d", pos, i, j);
    }
    else
        loc_output("@GOTO:%d,1@     ", pos);

    if (total)
    {
        if (total > 10000)
            i = (int)(((size / 100) * 100) / (total / 100));
        else
            i = (int)((100 * size) / total);

        loc_output("@GOTO:%d,1@%3d%%", pos+5, 100 - i);
        return i;
    }
    return -1;
}

void display_stat(int y, int x, long val)
{
    char tmp[30];

    sprintf(tmp, "%ld         ", val); tmp[10] = '\0';
    loc_output("@X0F@GOTO:%d,%d@%s", x, y+1, tmp);
}

#define BARHEIGHT 8

void display_bar(int size, int pos)
{
    int i, j, n;

    if (size < 0) return;
    loc_output("@X2D");

    i = (size * (2 * BARHEIGHT) + 99) / 100;
    j = i & 1;
    i = i / 2 + 2;
    for (n = 2; n <= BARHEIGHT + 1; n++)
    {
        if (n < i)
            loc_output("@GOTO:%d,%d@   ", pos, n+1);
        else if (n > i || !j)
        {
#ifdef UNIX
            loc_output("@GOTO:%d,%d@XXX", pos, n+1);
#else
            loc_output("@GOTO:%d,%d@", pos, n+1);
#endif
        }
        else
        {
#ifdef UNIX
            loc_output("@GOTO:%d,%d@xxx", pos, n+1);
#else
            loc_output("@GOTO:%d,%d@", pos, n+1);
#endif
        }
    }
}

static char Space[] = "            ";
extern long downfiles_left;

void update_download(void)
{
    char *p;

    if (downfiles_left)
    {
        p = strrchr(dl->name, SLASH);
        if (p != NULL) p++; else p = dl->name;
    }
    else
    {
        p = Space;
    }

    loc_output("@X30@GOTO:3,1@%s", p);
}

void update_upload(void)
{
    char *p;

    if (uploading_list.first)
    {
        p = strrchr(uploading_list.first->name, SLASH);
        if (p != NULL) p++; else p = dl->name;
    }
    else
    {
        p = Space;
    }

    loc_output("@X30@GOTO:41,1@%s", p);
}

