#include <time.h>
#include "../memory.h"

#ifdef _AMIGA

void _splitpath(char *file, char *drive, char *dir, char *fname, char *ext);
void _makepath(char *file, char *drive, char *dir, char *fname, char *ext);

#define SWAPWORDS(a) ((((unsigned long)a) >> 16) | (((unsigned long)a) << 16))
#define SWAPBYTES(a) ((((unsigned short)a) >> 8 ) | (((unsigned short)a) << 8 ))

#define SH_DENYWR 0
#define SH_DENYRW 0
#define _fastcall __regargs
#define far
#define _far
#define _cdecl
#define _interrupt
#define _fmemcpy(a,b,c)	(memcpy((a),(b),(c)))
#define _fmalloc(a)	(malloc(a))
#define _fstrlen(a)	(strlen(a))
#define _fstrcpy(a,b)	(strcpy(a,b))
#define _ffree(a)	(_free(a))
#define cputs(a)	(puts(a))
#define putch(c)	(conwritechar(c))
#define putc(c)		(conwritechar(c))

int sopen(char *filename, int opts, int shopts, int mode);

int mux_setup(char *app, char ver, char *device, long speed, int carr, int hand, int terminal, int forcecap);

#endif
#ifdef LINUX

#define _far
#define _fastcall
#define _cdecl
#define _interrupt
#define _fmemcpy(a,b,c)	(memcpy((a),(b),(c)))
#define _fmalloc(a)	(_malloc(a))
#define _fstricmp(a,b)	(strcasecmp(a,b))
#define _fstrlen(a)	(strlen(a))
#define _fstrcpy(a,b)	(strcpy(a,b))
#define _ffree(a)	(_free(a))
#define cputs(a)	(fputs(a, stderr))
#define putch(c)	(fputc(c, stderr))
#define sopen(a,b,c,d)  (open(a,b,d))
#define O_BINARY 0
#define O_TEXT 0

int mux_setup(char *app, char ver);
#endif

#ifdef __OS2__

#define _far
#define _fastcall
#define _cdecl
#define _interrupt
#define _fmemcpy(a,b,c)	(memcpy((a),(b),(c)))
#define _fmalloc(a)	(_malloc(a))
#define _fstrlen(a)	(strlen(a))
#define _fstrcpy(a,b)	(strcpy(a,b))
#define _ffree(a)	(_free(a))

int mux_setup(char *app, char ver);
#endif

#ifdef MSDOS
int mux_setup(char *app, char ver);
#endif

void mux_shutdown(char *msg, int level, int wait);

void mux_run(void);
void mux_closed(int level);

void mux_open_tx_channel(int channel, int size, int opt);
int _fastcall mux_tx_used(int channel);
int _fastcall mux_tx_free(int channel);
int _fastcall mux_tx_ready(int channel);
int _fastcall mux_tx_data(int channel, char *ptr, int size);
void _fastcall mux_tx_flush(int channel);

void mux_open_rx_channel(int channel, int size);
int _fastcall mux_rx_used(int channel);
int _fastcall mux_rx_free(int channel);
int _fastcall mux_rx_data(int channel, char *ptr, int size);
void _fastcall mux_rx_flush(int channel);

extern unsigned char mslp_capsule[256];
extern int mux_errorlevel;
extern int mux_max_window;
extern int mux_window_size;
extern int mux_buffer;
extern int mux_packet_size;
extern int mux_max_size;
extern int mux_min_size;

extern long mux_packets_sent;
extern long mux_bytes_sent;
extern long mux_packets_lost;

extern long mux_packets_received;
extern long mux_bytes_received;
extern long mux_packets_missed;

extern unsigned long localserial;
extern unsigned long remoteserial;

#ifdef __OS2__
extern int quiet;
#endif

void bell(void);

extern char outmem[];
extern int telix_error;
extern int fifoin;
extern int fifoout;
extern int display_messages;
extern int exit_code;
extern int return_code;
extern char *initstring;
extern unsigned char mslp_mode[6];

#ifdef _AMIGA
#define timer timmeri
#endif
extern time_t timer;

void qcputs(char *str);

#define get_time() time(&timer)
#define elapsed(t) (long)(timer - t)

void store_break(void);
void restore_break(void);
void give_up(void);

void shutdown(void);

#ifndef SMODEM
extern unsigned Key;
#endif

/* kapselointikoodit */
#define OUTCAP 1
#define INPCAP 2
#define OUT7BIT 4
#define INP7BIT 8
#define OUTMAX 16
#define INPMAX 32
#define SERKEY 64

#define DC1 17
#define DC3 19

#define MUX_OPT_SLOW 0
#define MUX_OPT_FAST 1
#define MUX_OPT_TEXT 2

extern int mux_quit;
void close_channels(void);
