#define VERSION "v. 1.0 YAK"
#define VERNUM 99

struct file_entry
{
	struct file_entry _far *next;
	struct file_entry _far *prev;
	char status;
	long start;
	unsigned short time;
	unsigned short date;
	long size;
        //unsigned id;
#ifdef __linux__
        char name[0];
#else
        char name[];
#endif
};

#define HEADER_LEN 8

struct file_list
{
	struct file_entry _far *first;
	struct file_entry _far *last;
};

struct dir_path
{
        struct dir_path _far *next;
#ifdef __linux__
        char path[0];
#else
        char path[];
#endif
};

#define CH_SYSTEM 0
#define CH_CONTROL 1
#define CH_DOWNLOAD 2
#define CH_UPLOAD 3
#define CH_FIRST_OUTPUT 8
#define CH_LAST_OUTPUT 15
#define CH_FIRST_FILE 16
#define CH_LAST_FILE 31

#define MSG_TINY 'T'
#define MSG_SMALL 'S'
#define MSG_COMPACT 'C'
#define MSG_MEDIUM 'M'
#define MSG_LARGE 'L'
#define MSG_HUGE 'H'

#define BUCKETSIZE 1024

#ifdef UNIX
#define PATH_LEN PATH_MAX /* 1024 on Linux */
#else
#define PATH_LEN 128
#endif

extern int addusername;
extern char terminal_prompt[40];    
extern int promptlen;
extern char input[1000];
extern char Buffer[BUCKETSIZE];

extern long cur_download_bytes;
extern long cur_download_left;
extern long cur_upload_bytes;
extern long cur_upload_left;

extern int remotever;
extern int messages;
extern struct file_entry _far *dl;
extern struct file_list uploading_list;
extern struct dir_path _far *ulpath_first;
extern struct dir_path _far *ulpath_last;
extern struct dir_path _far *dlpath_first;
extern struct dir_path _far *dlpath_last;
extern long speed;
extern int update_packet;
extern int setup_packet;
extern char *logpath;
extern char termpath[PATH_LEN];
extern char dlpath[PATH_LEN];
extern char defpath[PATH_LEN];
extern int ulreq;
extern int wildcard;
extern int removefiles;
extern int includeaborted;
extern int deletefiles;
extern int dlreq;               
extern int autoexit;
extern int time_left;
extern int exit_delay_time;
extern int idle_delay_time;
extern int overwrite;
extern int renumber;
extern int restrict;             
extern int resume;        
extern time_t start_time;
extern time_t idle_start_time;
extern int logfile;
extern int quietstart;
extern int quietstop;

extern int txcps;
extern int rxcps;
extern int cur_rxcps;
extern int cur_txcps;

extern struct file_list send_upload_list;
extern struct file_list sent_upload_list;
extern struct file_list upload_list;
extern struct file_list uploading_list;
extern struct file_list download_list;
extern struct file_list downloaded_list;
extern struct file_list send_request_list;
extern struct file_list sent_request_list;

void message_run(void);
int keyboard_run(void);
int smodem_run(void);
int input_run(void);
char * _fastcall strspace(char *p);
int upload(char *file, char *lpath, char *rpath, char status);
int download(char *file, char *rpath, char *lpath);
int downloadname(char *file);
int xtoi(char *hex);
int set_packets(int msg);  
void open_channels(void);
void UpdateStat(int mode); 
void exit_smodem(void);                       
void abort_download(char error);
void abort_upload(char error);
void ErrMsg(char *Err, char *Msg);
void send_setup(void);

#ifdef SMODEM

#define MSG_DOWNLOAD 1
#define MSG_UPLOAD 2
#define MSG_EXIT 3
#define MSG_STAT 4
#define MSG_EDIT 5
#define MSG_QUIET 7
#define MSG_LOG 8
#define MSG_ERASE 9
#define MSG_SHELL 10
#define MSG_ABOUT 11
#define MSG_AUTOEXIT 12
#define MSG_YELL 13
#define MSG_COMMAND 14
#define MSG_UTIL 15
#define MSG_CLEAR 16

#define MSG_OK 1
#define MSG_CANCEL 2
#define MSG_LOCAL 3
#define MSG_REMOTE 4
#define MSG_PATH 5
#define MSG_INPUT 6
#define MSG_LIST 7
#define MSG_FULL 8
#define MSG_TRANSFER 10
#define MSG_BROWSE 11
#define MSG_DELETE 12
#define MSG_COPY 13
#define MSG_MOVE 14
#define MSG_NAME 15
#define MSG_FIRST 16
#define MSG_LAST 17
#define MSG_ABORT 18
#define MSG_UPLIST 19
#define MSG_DLLIST 20

extern unsigned long localcheck;
extern unsigned long remotecheck;

extern Window Terminal;
extern int remote_charset;
extern int busyrun;
void set_prompt(char *str);
void StoreLine(void);
extern int h_log;
extern Menu MaxSizeMenu;
extern Window MenuStat;                   
extern unsigned mcolor[];
extern int ViewStat;
extern DialogField InputDialogField[];
extern Dialog InputDialog;    
extern Menu SetMenu;
extern Menu SystemMenu;
extern Dialog UploadDialog;
extern Dialog DownloadDialog;
extern Window Statistics;
extern unsigned dcolor[];
extern unsigned scolor[];
extern char filename[PATH_LEN];

void runcommand(char *prog, char *cmd);
void change_quiet(void);
void Browse(char *filename);
void SmodemPro(void);
#endif

int display_time(int cps, long total, long size, int pos);
void display_stat(int y, int x, long val);
void display_bar(int size, int pos);
void update_upload(void);
void update_download(void);
